/************************************************************************/
/*																		*/
/*		dump_message													*/
/*																		*/
/*		Richard K. Nordin			11/20/87.							*/
/*																		*/
/*		Copyright  1987-88, Apple Computer, Inc.  All rights reserved.	*/
/*																		*/
/************************************************************************/


#include <Ctype.h>
#include <StdIO.h>
#include <Types.h>

#include "os.h"


/*	dump_message - Dump Message
 *
 */
	
void
dump_message(stream, msg)
FILE	*stream;	/* Output File Stream */
message	*msg;		/* Message */
{
	unsigned char	*data;			/* Temporary Pointer */
	unsigned char	*p;				/* Temporary Pointer */
	int				size;			/* Temporary */
	
	fprintf(stream, "To:     %8.8x    ", msg->mTo);
	fprintf(stream, "Code:       %4.4x    ", (unsigned short) msg->mCode);	
	fprintf(stream, "ID:         %8.8x\n", (unsigned long) msg->mId);
	
	fprintf(stream, "From:   %8.8x    ", msg->mFrom);
	fprintf(stream, "Status:     %4.4x    ", (unsigned short) msg->mStatus);
	fprintf(stream, "DataPtr:    %8.8x\n", (unsigned long) msg->mDataPtr);
	
	fprintf(stream, "                ");
	fprintf(stream, "Priority:   %4.4x    ", (unsigned short) msg->mPriority);	
	fprintf(stream, "DataSize:   %8.8x\n", (unsigned long) msg->mDataSize);
	
	fprintf(stream, "SData:  ");
	data = (char *) &msg->mSData[0];
	size = sizeof(msg->mSData);
	for (p = data; p < data + size; p++)
	{
		fprintf(stream, "%2.2x ", *p);
	}
	fprintf(stream, "  ");
	for (p = data; p < data + size; p++)
	{
		fprintf(stream, "%c", isprint(*p) ? *p : '.');
	}
	fprintf(stream, "\n");
	
	fprintf(stream, "OData:  ");
	data = (char *) &msg->mOData[0];
	size = sizeof(msg->mSData);
	for (p = data; p < data + size; p++)
	{
		fprintf(stream, "%2.2x ", *p);
	}
	fprintf(stream, "  ");
	for (p = data; p < data + size; p++)
	{
		fprintf(stream, "%c", isprint(*p) ? *p : '.');
	}
	fprintf(stream, "\n");
	
	return;
}
