/************************************************************************/
/*																		*/
/*		init															*/
/*																		*/
/*		Richard K. Nordin			11/20/87.							*/
/*																		*/
/*		Copyright  1987-88, Apple Computer, Inc.  All rights reserved.	*/
/*																		*/
/************************************************************************/


#include <StdIO.h>
#include <Types.h>

#include "os.h"


extern int		Count_a;			/* Count of -a Option Values */
extern int		Count_c;			/* Count of -c Option Values */
extern int		Count_d;			/* Count of -d Option Values */
extern int		Count_f;			/* Count of -f Option Values */
extern int		Count_i;			/* Count of -i Option Values */
extern int		Count_l;			/* Count of -l Option Values */
extern int		Count_p;			/* Count of -p Option Values */
extern int		Count_s;			/* Count of -s Option Values */
extern int		Count_t;			/* Count of -t Option Values */
	
extern long		Selection_a[256];	/* -a Option Values */
extern long		Selection_c[256];	/* -c Option Values */
extern long		Selection_d[256];	/* -d Option Values */
extern long		Selection_f[256];	/* -f Option Values */
extern long		Selection_i[256];	/* -i Option Values */
extern long		Selection_l[256];	/* -l Option Values */
extern long		Selection_p[256];	/* -p Option Values */
extern long		Selection_s[256];	/* -s Option Values */
extern long		Selection_t[256];	/* -t Option Values */
	
/*	init - Initialize
 *
 *
 */
	
void
init(argc, argv)
int		argc;		/* Argument Count */
char	*argv[];	/* Arguments */
{
	int		i;
	char	*s;
	
	Count_a = 0;
	Count_c = 0;
	Count_d = 0;
	Count_f = 0;
	Count_i = 0;
	Count_l = 0;
	Count_p = 0;
	Count_s = 0;
	Count_t = 0;
	
	for (i = 1; i < argc; i++)
	{
		s = argv[i];
		
		if (*s == '-')
		{
			switch (*++s)
			{
			case 'a':
				sscanf(++s, "%x", &Selection_a[Count_a++]);
				break;
				
			case 'c':
				sscanf(++s, "%x", &Selection_c[Count_c++]);
				break;
				
			case 'd':
				sscanf(++s, "%x", &Selection_d[Count_d++]);
				break;
				
			case 'f':
				sscanf(++s, "%x", &Selection_f[Count_f++]);
				break;
				
			case 'i':
				sscanf(++s, "%x", &Selection_i[Count_i++]);
				break;
				
			case 'l':
				sscanf(++s, "%x", &Selection_l[Count_l++]);
				break;
				
			case 'p':
				sscanf(++s, "%x", &Selection_p[Count_p++]);
				break;
				
			case 's':
				sscanf(++s, "%x", &Selection_s[Count_s++]);
				break;

			case 't':
				sscanf(++s, "%x", &Selection_t[Count_t++]);
				break;
			
			default:
				fprintf(stderr, "### DumpTrace: invalid option: \"%c\"\n", *s);
				fprintf(stderr, "# Usage: DumpTrace [-an -cn -dn -fn -in -ln -pn -sn -tn ...] [file ...]\n");
				fflush(stderr);
				exit(1);
			}
		}
	}
	
	return;
}
