/************************************************************************************/
/*																					*/
/*				testr - Test specific A/ROSE Prep features   						*/
/*																					*/
/*			 Copyright  1987-88, Apple Computer, Inc.  All rights reserved.		*/
/*																					*/
/************************************************************************************/

#include <stdio.h>
#include ":::A/ROSE:includes:OS.h"
#include ":::A/ROSE:includes:arose.h"
#include ":::A/ROSE:includes:Managers.h"
#include "ipcGdefs.h"
#include <Types.h>
#ifndef applec  if MPW 2.0 C
#include <Strings.h>
#endif

void	ChkAbort();
long	abort_count;
pascal	void	illegal ()
		extern	0x4afc;

tid_type	buf[16];

main()
{
	void			NameReg ();
	short			unregister_task ();
	register struct mMessage	*p;
	register	i;
	struct pb_lookup_tid	*pb;
	tid_type	tid;
	unsigned short index;
	void		unregister ();

	abort_count = 0;
	pb = (struct pb_lookup_tid *)malloc(1000 + sizeof(struct pb_lookup_tid));
	if (pb == 0)
		Debugger();
	pb->ltid_on.o_len = 1;
	pb->ltid_on.o_name[0] = '=';
	pb->ltid_tn.t_len = 1;
	pb->ltid_tn.t_name[0] = '=';
	pb->ltid_index = 0;
	pb->ltid_RAsize = 1000;

	printf("===============================\n");

	printf("IPCg.NameTID = %x\n", GetIPCg() -> NameTID);

	atexit (unregister);
	
	printf("Queue no. = %d\n", OpenQueue(ChkAbort));
	

	fflush(stdout);
	if (!Register_Task ("ammmm", "testr", Machine_Visible))
		Debugger ();
	printf ("GetNameTID = %x\n", GetNameTID ());
	index = 0;
	tid = Lookup_Task ("=", "=", GetNameTID (), &index);
	printf ("TID FOUND - tid = %x\n", tid);
	p = GetMsg();
	if (p == 0L)
		Debugger();
	else
	{
		p->mTo = 1;	/* Send to iccm!	*/
		p->mCode = ICC_GETIMMS;
		p->mDataPtr = (char *) buf;
		p->mDataSize = sizeof buf;
		printf("About to send msg = %X, ID = %08X\n", p, p->mId);
		printf("To: %08X, mCode = %d\n", p->mTo, p->mCode);
		fflush(stdout);
		Send(p);
		printf("---- Sent message, waiting for reply ----\n");
		fflush(stdout);
		p = Receive(0L, 0L, 0L, 0L, 0L);
		if((long) p <= 0)
			illegal ();
		printf("Received msg = %X, ID = %08X\n", p, p->mId);
		printf("From: %08X, To: %08X, mCode = %d, mStatus = %d\n",
			p->mFrom, p->mTo, p->mCode, p->mStatus);
		fflush(stdout);
		for (i = 0; i < 16; ++i)
		{
			printf("addr[%X] = %08X\t", i, buf[i]);
			if ((i&3) == 3)
				putchar('\n');
		}
		FreeMsg(p);
		fflush(stdout);
	}

	p = GetMsg();
	if (p == 0L)
		Debugger();
	else
	{
		p->mTo = 1;	/* Send to iccm!	*/
		p->mCode = ICC_GETCARDS;
		p->mDataPtr = (char *) buf;
		p->mDataSize = sizeof buf;
		printf("About to send msg = %X, ID = %08X\n", p, p->mId);
		printf("To: %08X, mCode = %d\n", p->mTo, p->mCode);
		fflush(stdout);
		Send(p);
		printf("---- Sent message, waiting for reply ----\n");
		fflush(stdout);
		p = Receive(0L, 0L, 0L, 0L, 0L);
		if((long) p <= 0)
			illegal ();
		printf("Received msg = %X, ID = %08X\n", p, p->mId);
		printf("From: %08X, To: %08X, mCode = %d, mStatus = %d\n",
			p->mFrom, p->mTo, p->mCode, p->mStatus);
		fflush(stdout);
		for (i = 0; i < 16; ++i)
		{
			printf("addr[%X] = %08X\t", i, buf[i]);
			if ((i&3) == 3)
				putchar('\n');
		}
		FreeMsg(p);
		fflush(stdout);
	}

/*	Do more stuff!	*/

	for (i = 0; i < 16; ++i)
	{
		if (buf[i] > 0)
		{
			p = GetMsg();
			if (p == 0)
				Debugger();
			p->mTo = buf[i];
			p->mCode = NM_LOOKUP_TID;
			p->mDataPtr = (char *)pb;
			p->mDataSize = 1000 + sizeof(struct pb_lookup_tid);
			p->mStatus = 0;
			pb->ltid_index = 0;
			printf("About to send msg = %X, ID = %08X\n", p, p->mId);
			printf("To: %08X, mCode = %d, mDataSize = %d\n", p->mTo,
				p->mCode, p->mDataSize);
			fflush(stdout);
			Send(p);
			printf("---- Sent message, waiting for reply ----\n");
			fflush(stdout);
			p = Receive(0L, 0L, 0L, 0L, 0L);
			if((long) p <= 0)
				illegal ();
			printf("Received msg = %X, ID = %08X\n", p, p->mId);
			printf("From: %08X, To: %08X, mCode = %d, mStatus = %d\n",
				p->mFrom, p->mTo, p->mCode, p->mStatus);
			fflush(stdout);
			FreeMsg(p);
		}
	}
		
/*	Check bad sends	*/

	for (i = 0; i < 16; ++i)
	{
		p = GetMsg();
		if (p == 0)
			Debugger();
		p->mTo = (i << 24) + 100;	/*	Bad tid	*/
		p->mCode = NM_LOOKUP_TID;
		p->mDataPtr = (char *)pb;
		p->mDataSize = 1000 + sizeof(struct pb_lookup_tid);
		p->mStatus = 0;
		pb->ltid_index = 0;
		printf("About to send msg = %X, ID = %08X\n", p, p->mId);
		printf("To: %08X, mCode = %d, mDataSize = %d\n", p->mTo,
			p->mCode, p->mDataSize);
		fflush(stdout);
		Send(p);
		printf("---- Sent message, waiting for reply ----\n");
		fflush(stdout);
		p = Receive(OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL,  
				OS_NO_TIMEOUT,0);
		if((long) p <= 0)
			illegal ();
		printf("Received msg = %X, ID = %08X\n", p, p->mId);
		printf("From: %08X, To: %08X, mCode = %d, mStatus = %d\n",
			p->mFrom, p->mTo, p->mCode, p->mStatus);
		fflush(stdout);
		FreeMsg(p);
	}

	printf("==================================\n");	
	fflush(stdout);
	CloseQueue();
	exit(0);
}
void	ChkAbort()
{
	if (abort_count++ > 1000000)	/* If we are not receiving a message - stop */
	{
		CloseQueue ();
		exit(1);
	}
	if ((abort_count % 100) == 0)
	{
		printf(".");
		if((abort_count %5000) == 0)
		{
			printf("\n");
		}
		fflush(stdout);
	}
	
}

void unregister ()
{
			
	CloseQueue ();
	printf ("CloseQueue Called\n");
	fflush (stdout);
}

