/************************************************************************************/
/*																					*/
/*				time messages  - Display diagnostic/informative messages			*/
/*																					*/
/*				Philip Rakity									8/27/87				*/
/*																					*/
/*			 Copyright  1987-88, Apple Computer, Inc.  All rights reserved.		*/
/*																					*/
/************************************************************************************/

#include	"os.h"
#include	"managers.h"
#include	<stdio.h>

#define		TOTAL	50000

	pascal void illegal ()
		extern	0x4afc;
		
static	char		object_name [] = "echo manager";
static	char		type_name []   = "echo manager";

/*
 *	timeit
 */
void main()
{
	tid_type		echo_tid;
	tid_type		my_tid;
	unsigned short	index;
	message			*m;
	long			starttime;
	long			stoptime;
	long			i;
	tid_type 		GetEchoTID ();
	void			unregister ();
		
	atexit (unregister);

	OpenQueue (0);
	index = 0;
	while (echo_tid = GetEchoTID (&index))
	{
		printf ("Starting message time test\n");
		fflush (stdout);
		printf ("echo tid = %x\n", echo_tid);
		my_tid = GetTID ();
		m = GetMsg();
		fflush (stdout);
		
		starttime = GetETick ();
	
		for (i = 0; i < TOTAL; i++)
		{
			m -> mTo = echo_tid;
			m -> mFrom = my_tid;
			m -> mCode = 100;
			Send (m);
			m = Receive( OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, OS_NO_TIMEOUT, 0 );
		}
		stoptime = GetETick ();
		FreeMsg (m);
		printf ("total messages = %d\n", TOTAL);
		printf ("start time = %x\n", starttime);
		printf ("stop time = %x\n", stoptime);
		printf ("TID = %x - echo tid = %x, messages per second = %d\n", my_tid,
			echo_tid, (TOTAL * GetTickPS())/(stoptime - starttime));
		fflush (stdout);
	}
	CloseQueue();
	exit(0);
}

void unregister ()
{
			
	CloseQueue ();
	printf ("CloseQueue Called\n");
	fflush (stdout);
}

static tid_type GetEchoTID (last_index)
short	*last_index;
{
	tid_type			echoTID;
	static	struct ra_GetCards	get_cards;
	message				*msgptr;
	unsigned short		index;
	short				s;

	echoTID = 0;
	
	if(*last_index == 0)
	{
		if (GetICCTID () != 0)
		{
			if ((msgptr = GetMsg ()) == NULL)
				return (echoTID);
		
			msgptr -> mCode = ICC_GETCARDS;
			msgptr -> mDataPtr = (char *) &get_cards;
			msgptr -> mDataSize = sizeof (struct ra_GetCards);
			msgptr -> mTo = GetICCTID ();
			Send (msgptr);
			
			msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, ICC_GETCARDS+1,  OS_NO_TIMEOUT, 0);
					
			FreeMsg (msgptr);
		}
		else
		{
			index = 0;
			echoTID = Lookup_Task (object_name, type_name, GetNameTID (), &index);
			return(echoTID);
		}
	}		

	for (s = *last_index; s < IC_MAXCARDS; s++)
	{
		if (get_cards.tid [s] > 0)
		{
			index = 0;
			if(echoTID = Lookup_Task (object_name, type_name,
						get_cards.tid [s], &index))
			{
				*last_index = s+1;
				return(echoTID);
			}
		}
	}
	return (echoTID);
}



