/****************************************************************************************/
/*																						*/
/*						example os main - ACK	 			.							*/
/*																						*/
/*																						*/
/*					Philip M. Rakity						08/01/87.					*/
/*																						*/
/*					Anumele D. Raja							04/24/91.					*/
/*																						*/
/*						Use CreateTask subroutine										*/
/*																						*/
/*				Copyright  1987-88, Apple Computer, Inc.  All rights reserved.			*/
/*																						*/
/****************************************************************************************/

#include "os.h"
#include "managers.h"
#include "arose.h"
#include "siop.h"

void	osinit ();
void	osstart ();

void	name_server ();
void	time_manager ();
void	echo_manager ();

void	time_tester ();
void	timeit ();
void	echo_example ();
void	trace_manager ();

void	tester ();
void	ICCM ();
void	remote_manager ();

long GetA5() = 0x200d;			/*  Move.L	A5,D0	;  to get the value of A5  */

pascal void illegal ()
		extern	0x4afc;

/*  Create Task  */

void CreateTask(void (*function)(), unsigned char priority, short stackSize, short heapSize)
{
	ST_PB stpb, *pb;
	tid_type TaskID;
	
	pb = &stpb;
	
	/*	Start the task - 0 heap.	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = stackSize;
	pb -> heap = heapSize;
	pb -> priority = priority;
	pb -> InitRegs.PC = function;
	pb -> InitRegs.A_Registers [5] = GetA5();
	pb -> ParentTID = GetTID();
	
	if ((TaskID = StartTask (pb)) == 0)
		illegal();
}

main ()
{

	osinit (cMaxMsg, cOSStack);	/* Init OS with cMaxMsg messages and cStackOS stack	*/

	/*	Start name server - priority 31, 4k stack, 0 heap.		Task 1		*/

	CreateTask(name_server, 31, 4096, 0);

	/*	Start timer manager - priority 30, 4k stack, 0 heap.	Task 2		*/

	CreateTask(time_manager, 30, 4096, 0);

	/*	Start ICC manager - priority 31, 128-byte stack, 0 heap. Task 3		*/
	
	CreateTask(ICCM, 31, 128, 0);
		
	/*	Start RSM manager - priority 30, 4k-byte stack, 0 heap.	Task 4		*/

	CreateTask(remote_manager, 30, 4096, 0);
		
	/*	Start echo manager - priority 30, 256 stack, 0 heap.	Task 5		*/

	CreateTask(echo_manager, 30, 256, 0);
		
	/*	Start the trace manager - priority 30, 1k stack, 0 heap.  Task 6	*/
	
	CreateTask(trace_manager, 30, 1024, 0);
		
	/*	Start echo example - priority 30, 128 stack, 0 heap.	Task 7		*/

	CreateTask(echo_example, 30, 256, 0);
		
	/*	Start name tester - priority 10, 4k stack, 1024 heap	Task 8		*/
	
	CreateTask(tester, 10, 4096, 1024);
		
	/*	Start timer tester - priority 10, 4k stack, 0 heap.		Task 9		*/

	CreateTask(time_tester, 10, 4096, 0);
	
	/*	Start timeit - priority 10, 4k stack, 0 heap.			Task 10		*/
	
	CreateTask(timeit, 10, 4096, 0);
	
	/*	Start operating system.												*/
	
	osstart	(TICK_MIN_MAJ, TICKS_PS);			/* start things up			*/

	illegal ();									/* should never get here	*/
}
