/*
	Object oriented example in A/ROSE
	
	Author:	Anumele D. Raja
	
	Original program design:  Raghavan, PhD
*/

#include <arose.h>
#include <managers.h>

#include <AROSEObj.h>

#define CO_RESUME  1
#define MAXPRIMES 20

extern pascal void illegal() = 0x4AFC;


long GetA5() = 0x200d;

#ifdef __safe_link
extern "C" {
#endif
void printf(char *,...);
#ifdef __safe_link
}
#endif

TGlobal global;

TCoroutine gennumTask;

void Wait()
{
	TRecvMsg rcvMsg;

	rcvMsg.MsgRecv(OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, 60*GetTickPS());
	rcvMsg.MsgFree();

	return;
}

void filter()
{
	int mine;
	TCoroutine myfilter;
	
	Wait();
	global.primes++;
	
	printf("\nPrime #%d is %d from Task %08X", global.primes, mine=global.number, GetTID());
	while (global.primes < global.maxprimes) {
		if (global.number % mine) {
			if (!myfilter) {
				myfilter.Instantiate(filter);
			}
			myfilter.Resume();
		}
		else
			gennumTask.Resume();
	}

	printf("\nEnd of Co-routine.  Stopping the task %08X", GetTID());
	myfilter.StopCoroutine();
	StopTask(GetTID());
}

void gennum()
{
	TCoroutine filterTask;
	
	Wait();
	filterTask.Instantiate(filter);
	
	for (;;) {
		++global.number;
		filterTask.Resume();
	}
}

void TCoroutine::Resume()
{
	TRecvMsg rcvMsg;
	TSendMsg sndMsg;

	sndMsg.MsgSend(TaskID, CO_RESUME);

	rcvMsg.MsgRecv(OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, 60*GetTickPS());
	rcvMsg.MsgFree();

	return;
}

void TCoroutine::Instantiate(void (*function)(), unsigned char priority, short stackSize)
{
	ST_PB stpb;
	stpb.CodeSegment = NULL;
	stpb.DataSegment = NULL;
	stpb.StartParmSegment = NULL;
	stpb.stack = stackSize;
	stpb.heap = 0;
	stpb.priority = priority;
	stpb.InitRegs.PC = (long)function;
	stpb.InitRegs.A_Registers [5] = GetA5();
	stpb.ParentTID = GetTID();
	if ((TaskID = StartTask (&stpb)) == 0)
		illegal ();
}

void main()
{
	global.number = 1;
	global.primes = 0;
	global.maxprimes = MAXPRIMES;

	gennumTask.Instantiate(gennum);
	gennumTask.Resume();
	gennumTask.StopCoroutine();
	printf("\nEnd of Program.\n");
}
