/*
	A/ROSE Objects
*/

class TCoroutine {
	tid_type TaskID;
public:
	TCoroutine(tid_type id=0) { TaskID = id; }
	void Instantiate(void (*function)()=0, unsigned char priority=10, short stackSize=512);
	~TCoroutine() {
		if (TaskID)
			StopTask(TaskID);
	}
	void StopCoroutine() {
		if (TaskID)
			StopTask(TaskID);
	}
	int operator!() { return !TaskID; };
	void Resume();
	void* operator new(unsigned int size) { return (TCoroutine *)GetMem(size); }
	void operator delete(void* ptr) { FreeMem((char*)ptr); }
};

class TMessage {
protected:
	struct mMessage *msg;
};

class TSendMsg : public TMessage {
public:
	TSendMsg() {
		msg = GetMsg();
		msg->mFrom = GetTID();
	}
	void MsgSend(tid_type to, unsigned short code) {
		msg->mTo = to;
		msg->mCode = code;
		Send(msg);
	}
};

class TRecvMsg : public TMessage {
public:
	TRecvMsg() { msg = 0; }
	~TRecvMsg() {};
	void MsgRecv(long id, tid_type from, unsigned short code, long timeout)
	{
		msg = Receive(id, from, code, timeout);
	}
	void MsgFree() { 
		if (msg) 
			FreeMsg(msg);
	}
};

class TGlobal {
public:
	int number, primes, maxprimes;
};
