/*
	SAServer: Standalone Server running on a NuBus card
	
	Written by:	Anumele D. Raja
	
	Date:		February 23, 1990
	
	Copyright  1990, Apple Computer, Inc.  All rights reserved.
*/

#include "os.h"
#include "managers.h"
#include "arose.h"

#define	TICKS_PS	19						/*	19 ticks per second				*/
#define	TICK_MIN_MAJ 8						/*  8 minor ticks per major tick	*/
#define cMaxMsg		500						/*  500 messages					*/
#define cOSStack	4096					/*  System stack					*/

void	osinit ();
void	osstart ();
void	name_server ();
void	echo_manager ();
void	ICCM ();
void	remote_manager ();
void	trace_manager ();
void	server();

pascal void illegal ()
		extern	0x4afc;

long GetA5() = 0x200d;			/*  Move.L	A5,D0	;  to get the value of A5  */

/*  Create Task  */

tid_type CreateTask(function, priority, stackSize)
void (*function)();
unsigned char priority;
short stackSize;
{
	ST_PB stpb, *pb;
	tid_type TaskID;
	
	pb = &stpb;
	
	/*	Start the task - 0 heap.	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = stackSize;
	pb -> heap = 0;
	pb -> priority = priority;
	pb -> InitRegs.PC = function;
	pb -> InitRegs.A_Registers [5] = GetA5();
	pb -> ParentTID = GetTID();
	
	TaskID = StartTask (pb);

	return TaskID;

}

main ()
{

	struct ST_PB stpb, *pb;

	osinit (cMaxMsg, cOSStack);	/* Init OS with cMaxMsg messages and cStackOS stack	*/

	pb = &stpb;

	/*	Start name server - priority 31, 4k stack, 0 heap.		Task 1				*/

	if (CreateTask(name_server, 31, 4096) == 0)
		illegal();

	/*	Start ICC manager - priority 31, 128-byte stack, 0 heap. Task 2	*/
	
	if (CreateTask(ICCM, 31, 128) == 0)
		illegal();
		
	/*	Start RSM manager - priority 30, 4k-byte stack, 0 heap.	Task 3	*/

	if (CreateTask(remote_manager, 30, 4096) == 0)
		illegal();
		
	/*	Start echo manager - priority 30, 256 stack, 0 heap.	Task 4		*/

	if (CreateTask(echo_manager, 30, 256) == 0)
		illegal();
		
	/*  Start the server task - priority 10, 1024 stack, 0 heap.  Task 5	*/
	
	if (CreateTask(server, 10, 1024) == 0)
		illegal();
	
	/*	Start the trace manager - priority 30, 1k stack, 0 heap.  Task 6	*/
	
	if (CreateTask(trace_manager, 30, 1024) == 0)
		illegal();
		
	/*	Start operating system.											*/
	
	osstart	(TICK_MIN_MAJ, TICKS_PS);			/* start things up				*/

	illegal ();									/* should never get here		*/
}
