/*
	Semaphore.h  -  Header file for Semaphore support
*/

#include "arose.h"

#define P_SEM		2			/*  P operation  */
#define V_SEM		4			/*  V operation  */
#define D_SEM		10			/*  Semaphore destroyed  */
#define DIE			6			/*  Tell the semaphore to die  */
#define NO_MEM_SEM	8			/*  No memory to save task  */

/*  Error codes  */

#define NO_ERROR	0
#define NO_MESSAGE	1			/*  No message buffer available  */
#define SEM_DEAD	2			/*  Semaphore is dead  */

long GetA5() = 0x200d;			/*  Move.L	A5,D0	;  to get the value of A5  */

typedef tid_type Semaphore;		/*  Semaphore is basically a task ID  */

/*  Routine declarations  */

/*  Semaphore routines  */

Semaphore CreateSemaphore();
short DestroySemaphore(Semaphore);
short P_Semaphore(Semaphore);
short V_Semaphore(Semaphore);

/*  Task Routines  */

tid_type CreateTask(void (*)(), unsigned char);

pascal void illegal() extern	0x4afc;
