/****************************************************************************************/
/*																						*/
/*						Generic A/ROSE							.							*/
/*																						*/
/*																						*/
/*					Philip M. Rakity						08/01/87.					*/
/*					Anumele D. Raja							05/04/89.					*/
/*																						*/
/*				Copyright  1987-88, Apple Computer, Inc.  All rights reserved.			*/
/*																						*/
/****************************************************************************************/

#include "os.h"
#include "managers.h"
#include "arose.h"

#define	TICKS_PS	19						/*	19 ticks per second				*/
#define	TICK_MIN_MAJ 8						/* 8 minor ticks per major tick		*/

void	osinit ();
void	osstart ();
void	name_server ();
void	echo_manager ();
void	ICCM ();
void	remote_manager ();

pascal void illegal ()
		extern	0x4afc;

main ()
{

	struct ST_PB stpb, *pb;

	osinit (cMaxMsg, cOSStack);	/* Init OS with cMaxMsg messages and cStackOS stack	*/

	pb = &stpb;
	
/*	illegal();  */

	/*	Start name server - task 0 priority 31, 4k stack, 0 heap.							*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 31;
	pb -> InitRegs.PC = name_server;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();
		
	/*	Start ICC manager - task 1 priority 31, 128-byte stack, 0 heap.		*/
	
	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 128;
	pb -> heap = 0;
	pb -> priority = 31;
	pb -> InitRegs.PC = ICCM;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

	/*	Start RSM manager - task 2 priority 30, 4k-byte stack, 0 heap.			*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = remote_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();

	if (StartTask (pb) == 0)
		illegal ();
		
/*  If it is a test version do not include the following code  */

	/*	Start echo manager - task 4 priority 30, 128 stack, 0 heap.				*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 256;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = echo_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();
	
	/*	Start operating system.											*/
	
	osstart	(TICK_MIN_MAJ, TICKS_PS);			/* start things up				*/

	illegal ();									/* should never get here		*/
}
