/****************************************************************************************/
/*																						*/
/*						example os main - ACK	 			.							*/
/*																						*/
/*																						*/
/*					Philip M. Rakity						08/01/87.					*/
/*																						*/
/*				Copyright  1987-88, Apple Computer, Inc.  All rights reserved.			*/
/*																						*/
/****************************************************************************************/

#include "os.h"
#include "managers.h"
#include "arose.h"
#include "siop.h"

void	osinit ();
void	osstart ();
void	name_server ();
void	time_manager ();
void	echo_manager ();
#ifndef TestVer
void	sccreset ();
void	time_tester ();
void	timeit ();
void	echo_example ();
void	trace_manager ();

#ifdef PRINT
void	print_manager ();
#define PRINT_SLOT 0x00				/* default slot for printing	*/	
#endif PRINT

void	tester ();
void	MMSVP ();
void	MMSVPClient();
#endif TestVer
void	ICCM ();
void	remote_manager ();

#ifdef TestVer
void	Receiver();
void	Sender();
#endif

	pascal void illegal ()
		extern	0x4afc;
#pragma segment osmain
main ()
{

	struct ST_PB stpb, *pb;

	osinit (cMaxMsg, cOSStack);	/* Init OS with cMaxMsg messages and cStackOS stack	*/

	pb = &stpb;
	
/*	illegal();  */

#ifndef TestVer

	if (GetCard () == PRINT_SLOT)
		sccreset ();		/* Be sure SCC is reset...								*/
#endif TestVer

	/*	Start name server - priority 31, 4k stack, 0 heap.		Task 1				*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 31;
	pb -> InitRegs.PC = name_server;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

#ifndef TestVer

#ifdef PRINT
	if (GetCard () == PRINT_SLOT)
	{
		/*	Start print manager - priority 30, 4k stack, 0 heap.	Task 1	*/
	
		pb -> CodeSegment = NULL;
		pb -> DataSegment = NULL;
		pb -> StartParmSegment = GetMem (1);
	
		/* set print manager to print from slot PRINT_SLOT.  This allows all	*/
		/* cards to send their output to one slot for printing.  If printing is	*/
		/* desired on each card individually, then replace the line below 		*/
		/* with the following:													*/
		/*																		*/
		/*	*(pb -> StartParmSegment) = GetCard ();								*/
	
			
		*(pb -> StartParmSegment) = PRINT_SLOT;
		pb -> stack = 4096;
		pb -> heap = 0;
		pb -> priority = 30;
		pb -> InitRegs.PC = print_manager;
		pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
		pb -> ParentTID = GetTID();
		
		if (StartTask (pb) == 0)
			illegal ();
	}

#endif PRINT

#endif TestVer

	/*	Start timer manager - priority 30, 4k stack, 0 heap.	Task 2	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = time_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();

	if (StartTask (pb) == 0)
		illegal ();	
		
	/*	Start ICC manager - priority 31, 4k-byte stack, 0 heap. Task 3	*/
	
	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 0x1000;
	pb -> heap = 0;
	pb -> priority = 31;
	pb -> InitRegs.PC = ICCM;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

	/*	Start RSM manager - priority 30, 4k-byte stack, 0 heap.	Task 4	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = remote_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();

	if (StartTask (pb) == 0)
		illegal ();
		
/*  If it is a test version do not include the following code  */

#ifndef TestVer

	/*	Start echo manager - priority 30, 128 stack, 0 heap.	Task 5		*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 256;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = echo_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();
	
	/*	Start trace manager - priority 30, 1k stack, 0 heap.	Task 6		*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 1024;
	pb -> heap = 0;
	pb -> priority = 30; 
	pb -> InitRegs.PC = trace_manager;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

	/*	Start echo example - priority 30, 128 stack, 0 heap.	Task 7		*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 256;
	pb -> heap = 0;
	pb -> priority = 30;
	pb -> InitRegs.PC = echo_example;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

	/*	Start name tester - priority 10, 4k stack, 1024 heap	Task 8		*/
	
	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 1024;
	pb -> priority = 10;
	pb -> InitRegs.PC = tester;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();

	if (StartTask (pb) == 0)
		illegal ();

	/*	Start timer tester - priority 10, 4k stack, 0 heap.		Task 9	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 10;
	pb -> InitRegs.PC = time_tester;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();

	/*	Start timerit - priority 10, 4k stack, 0 heap.		Task 10	*/

	pb -> CodeSegment = NULL;
	pb -> DataSegment = NULL;
	pb -> StartParmSegment = NULL;
	pb -> stack = 4096;
	pb -> heap = 0;
	pb -> priority = 10;
	pb -> InitRegs.PC = timeit;
	pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
	pb -> ParentTID = GetTID();
	
	if (StartTask (pb) == 0)
		illegal ();	

#ifdef	0
	if( (GetgCommon() -> gBoardID ==  0x0d) || (GetgCommon() -> gBoardID == 0x0b) 
		|| (GetgCommon() -> gBoardID == 0x0a) )
	{

		/*	WHJW: Start MMSVP - priority 10, 4k stack, 0 heap.				*/
	
		pb -> CodeSegment = NULL;
		pb -> DataSegment = NULL;
		pb -> StartParmSegment = NULL;
		pb -> stack = 4096;
		pb -> heap = 0;
		pb -> priority = 10;
		pb -> InitRegs.PC = MMSVP;
		pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
		pb -> ParentTID = GetTID();
		
		if (StartTask (pb) == 0)
			illegal ();
			
		/*	WHJW: Start MMSVP client task - priority 11, 4k stack, 0 heap.				*/
	
		pb -> CodeSegment = NULL;
		pb -> DataSegment = NULL;
		pb -> StartParmSegment = NULL;
		pb -> stack = 4096;
		pb -> heap = 0;
		pb -> priority = 11;
		pb -> InitRegs.PC = MMSVPClient;
		pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
		pb -> ParentTID = GetTID();
		
		if (StartTask (pb) == 0)
			illegal ();

	}

#endif	0
#else
		/*	Start a special task that communicates with a program on normal slot		*/
	
		pb -> CodeSegment = NULL;
		pb -> DataSegment = NULL;
		pb -> StartParmSegment = NULL;
		pb -> stack = 4096;
		pb -> heap = 0;
		pb -> priority = 11;
		pb -> InitRegs.PC = Receiver;
		pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
		pb -> ParentTID = GetTID();
		
		if (StartTask (pb) == 0)
			illegal ();

		pb -> CodeSegment = NULL;
		pb -> DataSegment = NULL;
		pb -> StartParmSegment = NULL;
		pb -> stack = 4096;
		pb -> heap = 0;
		pb -> priority = 11;
		pb -> InitRegs.PC = Sender;
		pb -> InitRegs.A_Registers [5] = GetgCommon() -> gInitA5;
		pb -> ParentTID = GetTID();
		
		if (StartTask (pb) == 0)
			illegal ();

#endif TestVer

	/*	Start operating system.											*/
	
	osstart	(TICK_MIN_MAJ, TICKS_PS);			/* start things up				*/

	illegal ();									/* should never get here		*/
}
