/************************************************************************************/
/*																					*/
/*				timeIt - Timer test using echo.c									*/
/*																					*/
/*				Philip Rakity									8/27/87				*/
/*																					*/
/*			 Copyright  1987-88, Apple Computer, Inc.  All rights reserved.		*/
/*																					*/
/************************************************************************************/

#include	"os.h"
#include	"managers.h"

#define		TOTAL		50000
/* #define		All_Cards	0	/* 0 if only send messages only to local echo manager */

	pascal void illegal ()
		extern	0x4afc;

static	short		All_Cards	= 1;

static	char		object_name [] = "echo manager";
static	char		type_name []   = "echo manager";
static	long		counter;
message *InlReceive(mID, mCode, mFrom, mTimeOut) = { 0x204f, 0x4e46 };
void InlSend(message *m) = { 0x2057, 0x4e45 };

/*
 *	timeit
 */
void timeit()
{
	tid_type		echo_tid;
	tid_type		my_tid;
	message			*m;
	long			starttime;
	long			stoptime;
	long			i;
	short			index;
	tid_type 		GetEchoTID ();
	message			*Receive ();
	
	counter = 0;
	while (1)
	{
	index = 0;
		while (echo_tid = GetEchoTID (&index))
		{
			printf ("TID = %x - Starting message time test\n", GetTID ());
		
			printf ("TID = %x - echo tid = %x\n", GetTID (), echo_tid);
			my_tid = GetTID ();
			m = GetMsg();
			
			Reschedule (OS_BLOCK_MODE);
		
			starttime = GetETick ();
		
			for (i = 0; i < TOTAL; i++)
			{
				m -> mTo = echo_tid;
				m -> mFrom = my_tid;
				m -> mCode = 100;
				InlSend (m);
				m = InlReceive( OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, OS_NO_TIMEOUT );
			}
			stoptime = GetETick ();
			FreeMsg (m);
			
			printf ("TID = %x - total messages = %d pass = %d\n", GetTID (), TOTAL, ++counter);
			printf ("TID = %x - start time = %x stoptime = %x elapsed time = %x\n",
					GetTID (), starttime, stoptime, stoptime-starttime);
			if (stoptime == starttime)
			{
				printf ("TID = %x - CLOCK STOPPED!\n", GetTID ());
				illegal ();
			}
			else
			{
				printf ("TID = %x - echo tid = %x, messages per second = %d\n", GetTID (),
					echo_tid, (TOTAL * GetTickPS())/(stoptime - starttime));
			}
		}
	}
}

static tid_type GetEchoTID (last_index)
short	*last_index;
{
	tid_type			echoTID;
	static	struct ra_GetCards	get_cards;
	message				*msgptr;
	unsigned short		index;
	short				s;

	echoTID = 0;
	
	if(*last_index == 0)
	{
		if ((GetICCTID () != 0) && All_Cards)
		{
			if ((msgptr = GetMsg ()) == NULL)
				return (echoTID);
		
			msgptr -> mCode = ICC_GETCARDS;
			msgptr -> mDataPtr = (char *) &get_cards;
			msgptr -> mDataSize = sizeof (struct ra_GetCards);
			msgptr -> mTo = GetICCTID ();
			Send (msgptr);
			
			msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, ICC_GETCARDS+1,  OS_NO_TIMEOUT, 0);
					
			FreeMsg (msgptr);
		}
		else
		{
			index = 0;
			echoTID = Lookup_Task (object_name, type_name, GetNameTID (), &index);
			return(echoTID);
		}
	}		

	for (s = *last_index; s < IC_MAXCARDS; s++)
	{
		if (get_cards.tid [s] > 0)
		{
			index = 0;
			if(echoTID = Lookup_Task (object_name, type_name,
						get_cards.tid [s], &index))
			{
				*last_index = s+1;
				return(echoTID);
			}
		}
	}
	return (echoTID);
}


