/********************************************************************************/
/*																				*/
/*		costask.c - "C" version of A/ROSE ostask.								*/
/*																				*/
/*		February 20, 1991.  Richard W. Mincher and Richard H. Sackett.			*/
/*																				*/
/*		Copyright  1991, Apple Computer, Inc.  All rights reserved.			*/
/*																				*/
/********************************************************************************/

#include "os.h"
#include "arose.h"
#include "MachineDep.h"
#include "types.h"

/********************************************************************************/
/*																				*/
/*		pickTask - round robin selection of next available task to execute		*/
/*																				*/
/*																				*/
/*		Exit	- Current task and task list updated.							*/
/*																				*/
/********************************************************************************/

void
pickTask()
{
	register sPriority	*pList;
	register pTaskSave	*fTask, *task;
	
	pList = gCom->gPriList;							/*	Get priority list	*/
	while(pList != nil)								/*	While not end of list	*/
	{
		fTask = task = pList->sTask;				/*	First task pointer	*/
		do
		{
			if (task->pRcvFlag == nil)				/*	if not blocked	*/
			{
				pList->sTask = task->pNextTask;		/*	update task list pointer	*/
				gCom->gCurrTask = task;				/*	set current task	*/
				gCom->gTID = gCom->gTID & 0xffff0000 | task->pTID;
													/*	set tid	*/
				return;
			}
			task = task->pNextTask;					/*	Advance to next task	*/
		} 
		while (fTask != task);						/*	Until back to beginning	*/
		pList = pList->sNext;						/*	Advance to next priority	*/
	}

	gCom->gError = eNPTR;							/*	Set error (no tasks)	*/
	illegal();										/*	die	*/
}
