/********************************************************************************/
/*																				*/
/*		osgluedefs.c - "C" version of A/ROSE osgluedefs.						*/
/*																				*/
/*		February 20, 1991.  Richard W. Mincher and Richard H. Sackett.			*/
/*																				*/
/*		Copyright  1991, Apple Computer, Inc.  All rights reserved.			*/
/*																				*/
/********************************************************************************/

void cPostRTE(void);
extern	void			cAROSEFreeMem();
extern	void			cFreeMsg();
extern	char			*cAROSEGetMem();
extern	struct mMessage	*cGetMsg();
extern	struct mMessage	*cReceive();
extern	short			cReschedule();
extern	void			cSend();
extern	short			cSpl();
extern	tid_type		cStartTask();
extern	void			cStopTask();
extern	pascal void		cAROSESECS2DATE(unsigned long, AROSEDateTimeRec *);
pascal void				cAROSEDATE2SECS(Date, secs)
						AROSEDateTimeRec *Date;
						unsigned long *secs;
						extern;

extern	void			cAROSEBlockMove();
extern	unsigned long	cGetBSize();
extern	unsigned char	cGetCard();
pascal void				cAROSEGETDATETIME(secs)
						unsigned long *secs;
						extern;
extern	unsigned long	cGetETick();
extern	struct gCommon	*cGetgCommon();
extern	char			*cGetHeap();
extern	tid_type		cGetICCTID();
extern	tid_type		cGetIMMTID();
extern	tid_type		cGetNameTID();
extern	char			*cGetStParms();
extern	struct pTaskSave	*cGetTCB();
extern	unsigned short	cGetTickPS();
extern	tid_type		cGetTID();
extern	tid_type		cGetTimerTID();
extern	tid_type		cGetTraceTID();
extern	unsigned char	cGetUCount();
extern	unsigned char	cIncUCount();
extern	short			cIsLocal();
extern	tid_type		cLookup_Task();
extern	char			*cMapNuBus();
extern	char			cNet_Register_Task();
extern	char			cRegister_Task();
extern	void			cSuperCall();
extern	void			cSwapTID();
extern	char			*cToNuBus();
extern	void			cTraceReg();

extern	void			cBadCopyNuBus();
extern	void			cICCReg();
extern	void			cNameReg();
extern	void			cTimerReg();
extern	char			cIsTID(tidtype);
extern	void			cTLInitTimer();
extern	void			cTLStartTimer();
extern	void			cTLCancelTimer();
extern	void			cTLActiveTimer();
extern	void			cTLReceive();
extern	void			cTLInitTimer();
extern	void			cIMMReg(OSlong);
extern	short			cNetCopy(tid_type, void *, tid_type, void *, unsigned long);
extern OSlong			cCountFreeMem();
extern OSlong			cCountMaxMem();
extern OSlong			cGetTIDIMM(tid_type);
extern OSlong			cNetLookup();
extern void				cOpenSection();
extern void				cCloseSection();
extern OSshort			cCountFreeMsgs();
extern	short			cLockRealArea(void *, unsigned long, struct addressareas buffer[], unsigned long);
extern	short			cUnlockRealArea(void *, unsigned long);
extern	void			cIMMHReg(OSlong);
extern	void			cUnregister_Name(OSlong);

struct jmptbl {
	unsigned short jmp_instr;	/* jump instruction 	*/
	int (*proc)();				/* procedure to jump to */
};

#define NUM_PROCS	64
struct	jmptbl	TJmpT[NUM_PROCS] = {
	JMP_INSTR, cPostRTE,				// 0		
	JMP_INSTR, cAROSEFreeMem,		// 1	
	JMP_INSTR,cFreeMsg,				// 2	
	JMP_INSTR,cAROSEGetMem,			// 3	
	JMP_INSTR,cGetMsg,				// 4	
	JMP_INSTR,cReceive,				// 5	
	JMP_INSTR,cReschedule,			// 6	
	JMP_INSTR,cSend,					// 7		
	JMP_INSTR,cSpl,					// 8		
	JMP_INSTR,cStartTask,			// 9	
	JMP_INSTR,cStopTask,				// 10	
	JMP_INSTR,cAROSEBlockMove,		// 11
	JMP_INSTR,cBadCopyNuBus,			// 12
	JMP_INSTR,cGetBSize,				// 13
	JMP_INSTR,cGetCard,				// 14
	JMP_INSTR,cGetETick,				// 15
	JMP_INSTR,cGetgCommon,			// 16
	JMP_INSTR,cGetHeap,				// 17	
	JMP_INSTR,cGetStParms,			// 18
	JMP_INSTR,cGetTCB,				// 19
	JMP_INSTR,cGetTickPS,			// 20
	JMP_INSTR,cGetTID,				// 21
	JMP_INSTR,cGetICCTID,			// 22
	JMP_INSTR,cGetNameTID,			// 23
	JMP_INSTR,cGetTimerTID,			// 24
	JMP_INSTR,cGetTraceTID,			// 25
	JMP_INSTR,cGetUCount,			// 26
	JMP_INSTR,cICCReg,				// 27
	JMP_INSTR,cIncUCount,			// 28
	JMP_INSTR,cNameReg,				// 29
	JMP_INSTR,cTimerReg,			// 30
	JMP_INSTR,cTraceReg	,			// 31
	JMP_INSTR,cLookup_Task,			// 32
	JMP_INSTR,cRegister_Task,		// 33	
	JMP_INSTR,cMapNuBus,			// 34
	JMP_INSTR,cToNuBus,				// 35
	JMP_INSTR,cIsLocal,				// 36
	JMP_INSTR,cSwapTID,				// 37
	JMP_INSTR,cIsTID,				// 38
	JMP_INSTR,cTLInitTimer,			// 39
	JMP_INSTR,cTLStartTimer,		// 40
	JMP_INSTR,cTLCancelTimer,		// 41
	JMP_INSTR,cTLActiveTimer,		// 42
	JMP_INSTR,cTLReceive,			// 43
	JMP_INSTR,cAROSESECS2DATE,		// 44
	JMP_INSTR,cAROSEDATE2SECS,		// 45
	JMP_INSTR,cAROSEGETDATETIME,	// 46
	JMP_INSTR,cIMMReg,				// 47
	JMP_INSTR,cGetIMMTID,			// 48
	JMP_INSTR,cNetCopy,				// 49
	JMP_INSTR,cNet_Register_Task,	// 50
	JMP_INSTR,cCountFreeMem,		// 51
	JMP_INSTR,cCountMaxMem,			// 52
	JMP_INSTR,cSuperCall,			// 53
	JMP_INSTR,cGetTIDIMM,			// 54
	JMP_INSTR,cNetLookup,			// 55
	JMP_INSTR,cOpenSection,			// 56
	JMP_INSTR,cCloseSection,		// 57
	JMP_INSTR,cResetPageLatch,		// 58
	JMP_INSTR,cCountFreeMsgs,		// 59
	JMP_INSTR,cLockRealArea,		// 60
	JMP_INSTR,cUnlockRealArea,		// 61
	JMP_INSTR,cIMMHReg,				// 62
	JMP_INSTR,cUnregister_Name		// 63
};