/*

	Machine Dependent code

		Hank Sackett		1/8/91
		Copyright  1987-91,  Apple Computer, Inc.  All rights reserved.

*/



pascal void illegal()	extern	0x4afc;

#define ILLEGAL			0x4afc

typedef void (*TrapPtr)();
typedef long *VectorPtr;

/* exception vectors */

#define 	VECTOR_BASE 	0

#define 	INITIAL_SSP		((VectorPtr) (VECTOR_BASE + 0))
#define 	INITIAL_PC		((VectorPtr) (VECTOR_BASE + 4))
#define 	BUS_ERROR		((VectorPtr) (VECTOR_BASE + 8))
#define 	ADDRESS_ERROR	((VectorPtr) (VECTOR_BASE + 12))
#define 	ILLEGAL_INSTR	((VectorPtr) (VECTOR_BASE + 16))
#define 	ZERO_DIV		((VectorPtr) (VECTOR_BASE + 20))
#define 	CHK_INSTR		((VectorPtr) (VECTOR_BASE + 24))
#define 	TRAPV_INSTR		((VectorPtr) (VECTOR_BASE + 28))
#define 	PRIV_VIOL		((VectorPtr) (VECTOR_BASE + 32))
#define 	TRACE_VEC		((VectorPtr) (VECTOR_BASE + 36))
#define 	EMUL_1010		((VectorPtr) (VECTOR_BASE + 40))
#define 	EMUL_1111		((VectorPtr) (VECTOR_BASE + 44))
#define 	RSVD_1			((VectorPtr) (VECTOR_BASE + 48))
#define 	RSVD_2			((VectorPtr) (VECTOR_BASE + 52))
#define 	FORMAT_ERR		((VectorPtr) (VECTOR_BASE + 56))
#define 	UNINIT_INT		((VectorPtr) (VECTOR_BASE + 60))
#define 	RSVD_3			((VectorPtr) (VECTOR_BASE + 64))
#define 	RSVD_4			((VectorPtr) (VECTOR_BASE + 68))
#define 	RSVD_5			((VectorPtr) (VECTOR_BASE + 72))
#define 	RSVD_6			((VectorPtr) (VECTOR_BASE + 76))
#define 	RSVD_7			((VectorPtr) (VECTOR_BASE + 80))
#define 	RSVD_8			((VectorPtr) (VECTOR_BASE + 84))
#define 	RSVD_9			((VectorPtr) (VECTOR_BASE + 88))
#define 	RSVD_10			((VectorPtr) (VECTOR_BASE + 92))
#define 	SPURIOUS		((VectorPtr) (VECTOR_BASE + 96))
#define		LEVEL_1			((VectorPtr) (VECTOR_BASE + 100))		
#define		LEVEL_2			((VectorPtr) (VECTOR_BASE + 104))		
#define		LEVEL_3			((VectorPtr) (VECTOR_BASE + 108))		
#define		LEVEL_4			((VectorPtr) (VECTOR_BASE + 112))		
#define		LEVEL_5			((VectorPtr) (VECTOR_BASE + 116))		
#define		LEVEL_6			((VectorPtr) (VECTOR_BASE + 120))		
#define		LEVEL_7			((VectorPtr) (VECTOR_BASE + 124))		


void	DISABLE_INTRPT(void) = {0x007C, 0x0700};  		// ORI.W      #$0700,SR
short	GETSR(void)		extern 0x40c0;					// move.s sr,d0
long	GETA5(void)		extern 0x200d;					// move.l a5,d0
long	GETA7()			extern 0x200f;					// move.l a7,d0
void 	STOP(void) = {0x4e72, 0x2700};  				// STOP #$2700



#define JMP_INSTR	0x4ef9

#define gCom (( struct gCommon *) 0x400)

#define gROMProgFWA		((char *) 0x5C0	)		// 5C0 - Beginning of ROM Programmers area
#define gROMProgLWA		((char *) 0x5FF			// 5FF - End of ROM Programmers area


/* Debug */
struct dDebugArea {

	unsigned long	D_Registers[8];
	unsigned long	A_Registers[8];
	unsigned short	StatusRegister;
	unsigned long	ProgramCounter;
	unsigned long	UserStackPtr;
	unsigned char	BreakFlag;		// $FF at breakpoint, $00 on execution
	unsigned char	CommandCode;	// Set to appropriate DebugCode
	unsigned long	Reserved1;
	unsigned long	TrapNumber;
	unsigned long	MemoryAddress;
	unsigned long	MemoryValue;	// Memory location is right justified if word or byte
	unsigned char	MemorySize;		// value (0 = byte, 1 = word, 2 = long)
	unsigned char	CommandStatus;	// 0 If command accepted, $FF if command rejected
	unsigned char	Initialcrashflg;	// 0 if hwerr initially entered, 1 if hwbuserr initially entered

};

//struct	dDebugArea	dDebug;
#define dDebug (( struct dDebugArea *) 0x600)

#define	DebugAreaEnd	0x6FF		// Reserve area ($600 - $6FF) for any debugging needs
			
#define DebugCodeExecute	0
#define DebugCodeReadMem	1
#define DebugCodeWriteMem	2



