

/**********************************************************************
 *
 * Copyright Apple Computer, Inc. 1986
 * All Rights Reserved
 *
 *	crcPatch		: This program reads the code segment 1 from
 *						the Resource file and calculates the crc value.
 *						It then patches the file and saves it.
 *
 *	Author			: xxxxxx xxxxxx, July 30, 1986.
 *
 *	Mod History		: Nil.
 *
 **********************************************************************/
						

#include <stdio.h>
#include <types.h>
#include <osutils.h>
#include <files.h>
#include <resources.h>
#include <memory.h>
#include <errno.h>


pascal void debugger() extern 0xa9ff;


pascal void _CalcCRC (SizeCode,CodePtr,crc)
long		SizeCode;
Ptr			CodePtr;
long		*crc;
extern;

/******************************************************************
	Main
*******************************************************************/
main(argc,argv)

int	  argc;
char  *argv[];

{
  short		refnum;
  Handle	CodeHandle;		/* Handle to code resource */
  short		IOR;			/* IO Result */
  long		SizeCode;		/* Size of the code */
  Ptr		CodePtr;		/* Pointer to the code */
  long		crc;			/* the crc value */
		
  if (argc == 1)
    {
      fprintf(stderr,"### ERROR : No input file specified.\n");
      fprintf(stderr,"### SYNTAX: crcPatch  filename\n");
      fprintf(stderr,"### DSCRPT: Calculate and patch the crc value to code segment 1.\n");
    }
  else if (argc != 2)
    {
      fprintf(stderr,"### ERROR : Wrong number of parameters specified.\n");
      fprintf(stderr,"### SYNTAX: crcPatch  filename\n");
      fprintf(stderr,"### DSCRPT: Calculate and patch the crc value to code segment 1.\n");
    }
  else
    {
      refnum = openresfile(argv[1]);
	  if (refnum < 0 )
        fprintf(stderr,"### ERROR : Resource file: %s can't be opened. err = %d.\n",argv[1],refnum);
	  else
	    {
		   CodeHandle = GetResource('CODE',1);
	       HLock(CodeHandle);
	       IOR = ResError();
           if (IOR != 0)
             fprintf(stderr,"### ERROR : Code resource not available. Err = %d\n",IOR);
		   else
		     {
		      /* SizeCode = SizeResource(CodeHandle);*/
		       SizeCode = GetHandleSize(CodeHandle);
		       SizeCode = SizeCode - 4;										/* Skip first 4 bytes (Resource header) */			   
		       CodePtr = (Ptr) ( ((long) *CodeHandle) & 0x0FFFFFF) + 4;		/* Skip first 4 bytes (Resource header) */
		
		       _CalcCRC(SizeCode,CodePtr,&crc);								/* Calc and patch the crc value */

			   ChangedResource(CodeHandle);
			   IOR = ResError();
			   if (IOR != 0)
				 fprintf(stderr,"### ERROR : ChangedResource. Err = %d\n",IOR);

			   WriteResource(CodeHandle);
			   IOR = ResError();
			   if (IOR != 0)
				 fprintf(stderr,"### ERROR : WriteResource. Err = %d\n",IOR);

			   CloseResFile(refnum);
			   IOR = ResError();
			   if (IOR != 0)
				 fprintf(stderr,"### ERROR : CloseResFile. Err = %d\n",IOR);
			 }
	    }
	}
}

