/*
                                                                             
     File Name:    State_Storage_Manager.h                                   
     ----------                                                              
                                                                             
     Copyright  1990 Apple Computer, Inc.  All Rights Reserved              
                                                                             
         Description                                                         
         -----------                                                         
         This file contains the public interface to the state_storage record 
  		  of the SLUDGE cdev.  This record contains the current state (values)
  		  of the SLUDGE cdev.  It is saved as a resource of the cdev file     
  		  when SLUDGE is not active.										  
                                                                             
         History                                                             
         -------                                                             
                                                                             
         Author          Date            Description                         
         ------------------------------------------------------------------  
         Kevin McEntee   2/20/90         Original Implementation             
                                                                             
                                                                             
  */

#ifndef __STORAGE__
#define __STORAGE__

#include <Types.h>
#include <Memory.h>
#include <Lists.h>
#include <Dialogs.h>




typedef struct {
	Boolean			 About_Box_State;
	Boolean		     Allocated_State;
	Boolean		     Resource_Error_State;
	long		     State_Storage_Recommended_CDEV_Return_Value;
	Boolean		     On_Off_Error_Condition;
	long		     On_Off_Recommended_CDEV_Return_Value;
	Boolean		     ONFF_Value;	
	long			 Sludge_Factor;
	
	Ptr			 	Original_A_TRAP_Exception_Vector_Value;
	Ptr			 	Original_JUMP_TRACE_Exception_Vector_Value;
	
	Handle			Location_Of_Parasite_Resource;
} State_Storage_Record, *State_Storage_Pointer;	


void	Set_Location_Of_Parasite_Resource(Handle cdevStorage, Handle value);
Handle	Get_Location_Of_Parasite_Resource(Handle cdevStorage);


void 	Set_Original_A_TRAP_Exception_Vector_Value(Handle cdevStorage, Ptr value);
Ptr 	Get_Original_A_TRAP_Exception_Vector_Value(Handle cdevStorage);

void 	Set_Original_JUMP_TRACE_Exception_Vector_Value(Handle cdevStorage, Ptr value);
Ptr 	Get_Original_JUMP_TRACE_Exception_Vector_Value(Handle cdevStorage);


void 	Set_About_Box_State(Handle cdevStorage);
void	Clear_About_Box_State(Handle cdevStorage);
Boolean In_About_Box_State(Handle cdevStorage);



void 	Set_Sludge_Factor(Handle cdevStorage, int new_value);
void	Increment_Sludge_Factor(Handle cdevStorage);
void	Decrement_Sludge_Factor(Handle cdevStorage);
long	Get_Sludge_Factor(Handle cdevStorage);


void    Set_On_Off_Error_Condition(Handle cdevStorage, Boolean value);
Boolean Get_On_Off_Error_Condition(Handle cdevStorage);

void  Set_On_Off_Recommended_CDEV_Return_Value(Handle cdevStorage, long value);
long Get_On_Off_Recommended_CDEV_Return_Value(Handle cdevStorage);

short   Get_ONFF_Value(Handle cdevStorage);
void    Set_ONFF_Value(Handle cdevStorage, short value);


void SetUp_State_Storage(Handle *cdevStorage);

Boolean State_Storage_Allocated(Handle cdevStorage);
Boolean State_Storage_Nil(Handle cdevStorage);
Boolean State_Storage_Resource_Error(Handle cdevStorage);

long Get_State_Storage_Recommended_CDEV_Return_Value(Handle cdevStorage);



#endif __STORAGE__