// Nothing.r by Joost Kemink

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#if qDebug
include "Debug.rsrc";
#endif

include "MacApp.rsrc";
include "Dialog.rsrc";
include "Printing.rsrc";

include $$Shell("ObjApp")"Nothing" 'CODE';

// ---------------------------------------------------------------------------------------------

// Include the default resources

// If you want to re-specify any of these resources, remove the include statement that includes
// it from the "Defaults.rsrc"below and specify the resource yourself ("Defaults.r" may serve as
// a guideline on how to speficy your resource.

// View and window related resources

include "Defaults.rsrc" 'view' (kDefaultWindowID);
include "Defaults.rsrc" 'view' (kDefaultViewID);
include "Defaults.rsrc" 'WIND' (kDefaultWindowID);

// About box related resources

include "Defaults.rsrc" 'DITL' (phAboutApp);
include "Defaults.rsrc" 'ALRT' (phAboutApp);
include "Defaults.rsrc" 'STR#' (kDefaultCredits);

// Menu related resources

include "Defaults.rsrc" 'cmnu' (mApple);
include "Defaults.rsrc" 'cmnu' (mEdit);
include "Defaults.rsrc" 'cmnu' (mFile);
include "Defaults.rsrc" 'cmnu' (mBuzzwords);

// We redefine the 'MBAR' below, because we added a new menu to the default 'MBAR' resource,
// this means that we don't want to use the default 'MBAR' provided in "Defaults.rsrc", so
// comment it out.
// include "Defaults.rsrc" 'MBAR' (kMBarDisplayed);

// Finder related resources

include "Defaults.rsrc" 'ICN#' (128);
include "Defaults.rsrc" 'FREF' (128);
include "Defaults.rsrc" 'BNDL' (128);
include "Defaults.rsrc" 'vers' (2);
include "Defaults.rsrc" 'vers' (1);
include "Defaults.rsrc" 'MApp' (0);

// Miscellaneous resources

include "Defaults.rsrc" 'SIZE' (-1);

// --------------------------------------------------------------------------------------------------

#define	cOne	3001
#define	cTwo	3002
#define	cThree	3003
#define	cFour	3004
#define	cFive	3005
#define	cSix	3006
#define	cSeven	3007

#define mTest	40

resource 'cmnu' (mTest,
#if qNames
"mTest",
#endif
nonpurgeable) {
	mTest,
	textMenuProc,
	AllItems,
	enabled,
	"Test",
	{
	"One",		noIcon, "1",	noMark, plain, cOne;
	"Two",		noIcon, "2",	noMark, plain, cTwo;
	"Three",	noIcon, "3",	noMark, plain, cThree;
	"Four",		noIcon, "4",	noMark, plain, cFour;
	"Five",		noIcon, "5",	noMark, plain, cFive;
	"Six",		noIcon, "6",	noMark, plain, cSix;
	"Seven",	noIcon, "7",	noMark, plain, cSeven
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"kMBarDisplayed",
#endif
nonpurgeable) {

	{mApple; mFile; mEdit; mTest}
};

//	Include the separately compiled resources

include $$Shell("SrcApp")"NothingResources.rsrc";
