{ UOffscreenManager.p}
{ Copyright  1990, 1991 by Apple Computer, Inc. All rights reserved.}

{	Change List:

		ddmmyy
	GAP 060990	Modified USES when changing from Lightspeed Pascal to MPW.
	GAP 181290	Added comments.
	GAP	250191	Removed superfluous comments.
	GAP	250191	Added fDepthAndColorChecker to TOffscreenManager.
	GAP	250191	Got rid of, now obslolete, TOffscreenManager.Update.
	GAP	010491	Some reformatting and comments.

	End Change List. }

UNIT UOffscreenManager;

{	The UOffscreenManager unit provides capability for creating
	and managing virtual offscreen pixmaps that may span
	more than one graphics screen (GDevice).						}


INTERFACE

	USES

	{	Required for this unit's interface }

	{	MacApp }
		UMacApp,

	{	Other Building Blocks }
		UOSBitmap, UOSImage;


	TYPE

	{	TOffscreenManager manages a list of TOffscreenDevices that represent an
		area of the screen of fScreenRect size.  Each TOffscreenDevice as an
		associated GDevice which has an appropriate depth for each monitor on
		the user's system.															}

		TOffscreenManager = OBJECT(TObject)

				fDepthAndColorChecker : TEvtHandler;	{ A cohandler that periodically adjusts depth and color.	}
				fDesktopPort : GrafPtr;					{ GrafPort encompassing all screens.						}
				fScreenRect : Rect;						{ Area of screen stored offscreen.							}
				fList : TList;							{ A list of TOffscreenDevices.								}

				PROCEDURE TOffscreenManager.IOffscreenManager (size: Point);
				
				PROCEDURE TOffscreenManager.Free;
				OVERRIDE;
				
				PROCEDURE TOffscreenManager.Fields (PROCEDURE DoToField (fieldName: Str255;
																		 fieldAddr: Ptr;
																		 fieldType: INTEGER));
				OVERRIDE;
				
				PROCEDURE TOffscreenManager.CheckDepthAndColor;
				
				PROCEDURE TOffscreenManager.Draw (PROCEDURE QuickDrawStuff);
				
				PROCEDURE TOffscreenManager.CopyBitsFrom (srcBits: BitMap;
														  srcRect: Rect;
														  offscreenRect: Rect;
														  mode: INTEGER;
														  maskRgn: RgnHandle);
				
				PROCEDURE TOffscreenManager.CopyBitsFromScreen (screenRect: Rect;
																mode: INTEGER;
																maskRgn: RgnHandle);
				
				PROCEDURE TOffscreenManager.CopyBitsTo (dstBits: BitMap;
														dstRect: Rect;
														offscreenRect: Rect;
														mode: INTEGER;
														maskRgn: RgnHandle);
				
				PROCEDURE TOffscreenManager.CopyBitsToScreen (mode: INTEGER; maskRgn: RgnHandle);

			END; {TOffscreenDevice}


IMPLEMENTATION

	{$I $$Shell(SrcApp)UOffscreenManager.inc1.p}

END. {UOffscreenManager}