/*------------------------------------------------------------------------------
#	MPing 1.1 - MacTCP Ping Tool
#
#	Copyright  Apple Computer, Inc. 1990-1991
#	All rights reserved.
#
#	Versions:	
#				1.1		September 25, 1991.
#
#	File:
#				MPing.c
#
#	Components:
#				AddressXlation.h
#				MacTCPCommonTypes.h
#				Makefile
#				MiscIPPB.h
#				MPing.c
#				MPing.h
#				MPing.r
#				MPingDlg.c
#				MPingExtern.h
#				MPingGlobals.h
#				MPingIcmp.c
#				MPingWindow.c
#				resolver.c
------------------------------------------------------------------------------*/

#include "SysTypes.r"
#include "Types.r"

#include "MPing.h"

resource 'BNDL' (128) {
	'mPng',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'vers' (1) {
	0x02, 0x00, release, 0x00,
	verUS,
	"1.1",
	"1.1, Copyright \251 Apple Computer, Inc. 1990-1991."
};

/* this is a definition for a resource which contains only a rectangle */

type 'RECT' {
	rect;
};

/* we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenuBar, preload) {
	{ mApple, mFile, mEdit, mIPOptions };	/* four menus */
};

resource 'MENU' (mApple, preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About MPing",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile, textMenuProc,
	MenuItem12,				/* enable Quit only, program enables others */
	enabled, "File",
	{
		"New",
			noicon, "N", nomark, plain;
		"Open",
			noicon, "O", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Close",
			noicon, "W", nomark, plain;
		"Save",
			noicon, "S", nomark, plain;
		"Save As",
			noicon, nokey, nomark, plain;
		"Revert",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Page Setup",
			noicon, nokey, nomark, plain;
		"Print",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (mEdit, preload) {
	mEdit, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mIPOptions, preload) {
	mIPOptions, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "IP Options",
	 {
		"Record Route",
			noicon, nokey, nomark, plain;
		"Loose Source RR",
			noicon, nokey, nomark, plain;
		"Strict Source RR",
			noicon, nokey, nomark, plain;
		"TimeStamp",
			noicon, nokey, nomark, plain;
		"Security",
			noicon, nokey, nomark, plain;
		"Stream Identifier",
			noicon, nokey, nomark, plain
	}
};

/* this ALRT and DITL are used as an About screen */

resource 'ALRT' (rAboutAlert, purgeable) {
	{40, 20, 144, 300},
	rAboutAlert,
	{ /* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (rAboutAlert, purgeable) {
	{ /* array DITLarray: 6 elements */
		/* [1] */
		{74, 185, 94, 265},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 8, 24, 214},
		StaticText {
			disabled,
			"MPing 1.1 - MacTCP Ping Tool"
		},
		/* [3] */
		{32, 8, 48, 296},
		StaticText {
			disabled,
			"Copyright  Apple Computer 1990-1991"
		},
		/* [4] */
		{56, 8, 72, 136},
		StaticText {
			disabled,
			"Brought to you by:"
		},
		/* [5] */
		{80, 16, 96, 167},
		StaticText {
			disabled,
			"Rajesh Bhatawadekar"
		},
		/* [6] */
		{0, 0, 0, 0},
		HelpItem {
			disabled,
			HMScanhdlg {
				-2999
			}
		}
	}
};

/* this ALRT and DITL are used as an error screen */

resource 'ALRT' (rUserAlert, purgeable) {
	{40, 20, 140, 280},
	rUserAlert,
	{ /* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (rUserAlert, purgeable) {
	{ /* array DITLarray: 3 elements */
		/* [1] */
		{70, 165, 90, 250},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 50, 60, 240},
		StaticText {
			disabled,
			"MPing Error: ^0."
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon {
			disabled,
			2
		}
	}
};

resource 'CNTL' (rVScroll, preload, purgeable) {
	{160, 395, 265, 410},
	0, visible, 0, 0, scrollBarProc, 0, ""
};

resource 'RECT' (rMsgRect, preload, purgeable) {
	{160, 20, 265, 410}
};

resource 'DLOG' (rDialog, purgeable) {
	{40, 40, 340, 470},
	rDocProc,
	invisible,
	noGoAway,
	0x0,
	rDialog,
	"ICMP information"
};

resource 'DITL' (rDialog, purgeable) {
	{	/* array DITLarray: 21 elements */
		/* [1] */
		{275, 60, 290, 135},
		Button {
			enabled,
			"Ping Go"
		},
		/* [2] */
		{275, 185, 290, 260},
		Button {
			enabled,
			"Ping Stop"
		},
		/* [3] */
		{275, 310, 290, 385},
		Button {
			enabled,
			"Quit"
		},
		/* [4] */
		{10, 25, 25, 120},
		StaticText {
			disabled,
			"Host Address"
		},
		/* [5] */
		{10, 135, 25, 375},
		EditText {
			enabled,
			""
		},
		/* [6] */
		{35, 25, 50, 120},
		RadioButton {
			enabled,
			"Send text"
		},
		/* [7] */
		{35, 135, 50, 375},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{60, 25, 75, 170},
		RadioButton {
			enabled,
			"Send pattern (Hex)"
		},
		/* [9] */
		{60, 175, 75, 375},
		EditText {
			enabled,
			""
		},
		/* [10] */
		{85, 25, 100, 120},
		StaticText {
			disabled,
			"Packet Size"
		},
		/* [11] */
		{85, 120, 100, 155},
		EditText {
			enabled,
			""
		},
		/* [12] */
		{85, 170, 100, 230},
		StaticText {
			disabled,
			"Output :"
		},
		/* [13] */
		{85, 240, 100, 305},
		RadioButton {
			enabled,
			"Quiet"
		},
		/* [14] */
		{85, 310, 100, 385},
		RadioButton {
			enabled,
			"Verbose"
		},
		/* [15] */
		{110, 25, 125, 80},
		CheckBox {
			enabled,
			"Send"
		},
		/* [16] */
		{110, 85, 125, 155},
		EditText {
			enabled,
			""
		},
		/* [17] */
		{110, 170, 125, 300},
		StaticText {
			disabled,
			"number of packets"
		},
		/* [18] */
		{135, 25, 150, 65},
		StaticText {
			disabled,
			"Wait"
		},
		/* [19] */
		{135, 70, 150, 120},
		EditText {
			enabled,
			""
		},
		/* [20] */
		{135, 135, 150, 390},
		StaticText {
			disabled,
			"ticks between sending each packet"
		},
		/* [21] */
		{0, 0, 0, 0},
		HelpItem {
			disabled,
			HMScanhdlg {
				-2997
			}
		}
	}
};

/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	multiFinderAware,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	dontGetFrontClicks,			/* change this is if you want "do first click" behavior like the Finder */
	ignoreChildDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	not32BitCompatible,			/* this app should not be run in 32-bit address space */
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};

resource 'STR#' (rErrorStrings) {
	{
		"**********  MPing Statistics  **********\n";
		"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
		"Packets out/in/bad/%loss = ";
		"Round-trip time (ticks) min/avg/max = ";
		"Cannot open Resolver";
		"Cannot exceed 32,000 characters";
		"You must run on 512Ke or later";
		"Application Memory Size is too small";
		"Cannot create window";
		"Cannot open RECT resource";
		"Cannot create TextEdit record";
		"Cannot open vertical scroll bar control";
		"Cannot open menu resource";
		"Host not responding\n";
		"Recorded Route\n";
		"No routes recorded\n";
		"Minimum value: 1 tick";
		"success: pkt #/round-trip time/pkt length = ";
		"timeout: pkt # = ";
		"Source: ";
		"Destination: "
	};
};

resource 'STR#' (-3000, "Balloon Help String 1") {
	{	/* array StringArray: 24 elements */
		/* [1] */
		"Is this cool or what !",
		/* [2] */
		"Click, to start sending ICMP ECHO_REQUES"
		"T packets to destination host.",
		/* [3] */
		"Click, to stop sending ICMP ECHO_REQUEST"
		" packets to destination host.",
		/* [4] */
		"Click, to quit the application.",
		/* [5] */
		"Destination host address to be pinged.",
		/* [6] */
		"Enter destination host address here (nam"
		"e or IP number).",
		/* [7] */
		"Click, to send ASCII string as data.",
		/* [8] */
		"Send ASCII string as data.",
		/* [9] */
		"Enter ASCII data here.",
		/* [10] */
		"Click, to send Hex pattern as data.",
		/* [11] */
		"Send Hex pattern as data.",
		/* [12] */
		"Enter hex pattern here (0-9A-F).",
		/* [13] */
		"Number of bytes to be sent.",
		/* [14] */
		"Enter size here.",
		/* [15] */
		"Show Round-trip times and packet loss st"
		"atistics in the following rectangular ar"
		"ea. (All timings are in ticks.)",
		/* [16] */
		"Click, to show only statistics.",
		/* [17] */
		"Display only statistics.",
		/* [18] */
		"Click, to show error messages.",
		/* [19] */
		"Display error messages.",
		/* [20] */
		"Continue sending ECHO_REQUEST packets un"
		"til user clicks on stop button.",
		/* [21] */
		"Stop after receiving count ECHO_RESPONSE"
		" packets from host.",
		/* [22] */
		"Enter number of packets here.",
		/* [23] */
		"Wait given number of ticks before sendin"
		"g each packet. (1 tick = 1/60th of a sec"
		"ond or approx. 17 milliseconds",
		/* [24] */
		"Enter number of ticks. (Minimum is 1)"
	}
};

resource 'acur' (128) {
	{	/* array CursIdArray: 4 elements */
		/* [1] */
		128,
		/* [2] */
		129,
		/* [3] */
		130,
		/* [4] */
		131
	}
};

resource 'CURS' (128) {
	$"03E0 0790 0F00 0E00 0E00 0600 0200 0100"
	$"0080 0040 0060 0070 0070 00F0 09E0 07C0",
	$"0260 0490 0900 0A00 0A00 0600 0200 0100"
	$"0080 0040 0060 0050 0050 0090 0920 0640",
	{8, 8}
};

resource 'CURS' (129) {
	$"0000 0038 007C 00FE 01C1 0180 0100 0100"
	$"0080 0080 0180 8380 7F00 3E00 1C",
	$"0000 0038 0044 00BE 0141 0180 0100 0100"
	$"0080 0080 0180 8280 7D00 2200 1C",
	{8, 8}
};

resource 'CURS' (130) {
	$"0000 0000 0000 0000 401C 803E 807F C087"
	$"E103 FE01 7C01 3802",
	$"0000 0000 0000 0000 401C 8022 8079 4084"
	$"2102 9E01 4401 3802",
	{8, 8}
};

resource 'CURS' (131) {
	$"0800 1000 3000 7000 7000 7000 3800 1CF0"
	$"0F38 001C 000E 000E 000E 000C 0008 0010",
	$"0800 1000 3000 5000 5000 5000 2800 14F0"
	$"0F28 0014 000A 000A 000A 000C 0008 0010",
	{8, 8}
};

resource 'ICN#' (128, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 1FFF FFE0 1000 0020 17FF FFA0"
		$"1400 00A0 1400 07BC 1400 0208 1400 0110"
		$"1400 00A0 1400 0040 1400 07FC 7F00 0404"
		$"8080 05F4 BE80 0514 A280 0514 A280 05F4"
		$"BE80 0404 8080 1FFF AE80 1001 8080 1401"
		$"7F00 1FFF 0800 00A0 1400 00A0 2200 00A0"
		$"4100 00A0 F780 00A0 1400 00A0 17FF FFA0"
		$"1000 0020 1FFF FFE0",
		/* [2] */
		$"0000 0000 1FFF FFE0 1FFF FFE0 1FFF FFE0"
		$"1C00 00E0 1C00 07FC 1C00 03F8 1C00 01F0"
		$"1C00 00E0 1C00 0040 1C00 07FC 7F00 07FC"
		$"FF80 07FC FF80 07FC FF80 07FC FF80 07FC"
		$"FF80 07FC FF80 1FFF FF80 1FFF FF80 1FFF"
		$"7F00 1FFF 0800 00E0 1C00 00E0 3E00 00E0"
		$"7F00 00E0 FF80 00E0 1C00 00E0 1FFF FFE0"
		$"1FFF FFE0 1FFF FFE0"
	}
};

resource 'icl8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FF00 0000 0000"
	$"0000 00FF F5F5 F5F5 F5F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F62B 2B2B 2B2B FF00 0000 0000"
	$"0000 00FF F5FF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FF2B FF00 0000 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FF2B FF00 0000 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 00FF FFFF FF2B FFFF FFFF 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFF8 2B2B 2BF8 FF00 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF F8F8 F8FF 0000 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFFB FF00 0000 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF 0000 0000 0000"
	$"0000 00FF F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 00FF FFFF FFFF FFFF FFFF 0000"
	$"00FF FFFF FFFF FFFF 0000 0000 0000 0000"
	$"0000 0000 00FF 2B2B 2B2B 2B2B 2BFF 0000"
	$"FF2B 2B2B 2B2B 2B2B FF00 0000 0000 0000"
	$"0000 0000 00FF 2BFC FCFC FCFC 2BFF 0000"
	$"FF2B FCFC FCFC FC2B FF00 0000 0000 0000"
	$"0000 0000 00FF 2BFC 2A2A 2A00 2BFF 0000"
	$"FF2B FC2A 2A2A 002B FF00 0000 0000 0000"
	$"0000 0000 00FF 2BFC 2A2A 2A00 2BFF 0000"
	$"FF2B FC2A 2A2A 002B FF00 0000 0000 0000"
	$"0000 0000 00FF 2BFC 0000 0000 2BFF 0000"
	$"FF2B FC00 0000 002B FF00 0000 0000 0000"
	$"0000 0000 00FF 2B2B 2B2B 2B2B 2BFF 0000"
	$"FF2B 2B2B 2BF7 F72B FF00 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FF2B E32B FFFF FF2B FF00 0000 0000 0000"
	$"0000 00FF 2B2B 2B2B 2B2B 2B2B 2B2B 2BFF"
	$"FF2B 2B2B 2B2B 2B2B FF00 0000 0000 0000"
	$"0000 00FF 2BD8 2B2B 2B2B 2B2B 2B2B 2BFF"
	$"00FF FFFF FFFF FFFF 0000 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"0000 0000 FF00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"0000 00FF FBFF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"0000 FFF8 F8F8 FF00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"00FF F82B 2B2B F8FF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"FFFF FFFF 2BFF FFFF FF00 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"0000 00FF 2BFF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"0000 00FF 2BFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFF5 FF00 0000 0000"
	$"0000 00FF 2B2B F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F5F5 F5F5 F5F5 FF00 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 3FFC 2004 200E 2004 201E F012 903F"
		$"9021 F03F 2004 7004 2004 3FFC",
		/* [2] */
		$"0000 3FFC 2004 200E 2004 201E F01E F03F"
		$"F03F F03F 2004 7004 2004 3FFC"
	}
};

resource 'ics4' (128) {
	$"0000 0000 0000 0000 00FF FFFF FFFF FF00"
	$"00F0 0000 0000 0F00 00F0 0000 0000 FFF0"
	$"00F0 0000 0000 0F00 00F0 0000 000F FFF0"
	$"FFFF 0000 000F 0DF0 F0DF 0000 00FF FFFF"
	$"FCCF 0000 00FC CCCF FFFF 0000 00FF FFFF"
	$"00F0 0000 0000 0F00 0FFF 0000 0000 0F00"
	$"00F0 0000 0000 0F00 00FF FFFF FFFF FF"
};

resource 'icl4' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"000F FFFF FFFF FFFF FFFF FFFF FFF0 0000"
	$"000F CCCC CCCC CCCC CCCC CCCC DDF0 0000"
	$"000F CFFF FFFF FFFF FFFF FFFF FDF0 0000"
	$"000F CF00 0000 0000 0000 0000 FDF0 0000"
	$"000F CF00 0000 0000 0000 0FFF FDFF FF00"
	$"000F CF00 0000 0000 0000 00FE DDDE F000"
	$"000F CF00 0000 0000 0000 000F EEEF 0000"
	$"000F CF00 0000 0000 0000 0000 FEF0 0000"
	$"000F CF00 0000 0000 0000 0000 0F00 0000"
	$"000F CF00 0000 0000 0000 0FFF FFFF FF00"
	$"0FFF FFFF 0000 0000 0000 0FCC CCCC CF00"
	$"FCCC CCCC F000 0000 0000 0FCE EEEE CF00"
	$"FCEE EEEC F000 0000 0000 0FCE CCC0 CF00"
	$"FCEC CC0C F000 0000 0000 0FCE CCC0 CF00"
	$"FCEC CC0C F000 0000 0000 0FCE 0000 CF00"
	$"FCE0 000C F000 0000 0000 0FCC CCCC CF00"
	$"FCCC CCCC F000 0000 000F FFFF FFFF FFFF"
	$"FC8C FFFC F000 0000 000F CCCC CCCC CCCF"
	$"FCCC CCCC F000 0000 000F C3CC CCCC CCCF"
	$"0FFF FFFF 0000 0000 000F FFFF FFFF FFFF"
	$"0000 F000 0000 0000 0000 0000 FCF0 0000"
	$"000F EF00 0000 0000 0000 0000 FCF0 0000"
	$"00FE EEF0 0000 0000 0000 0000 FCF0 0000"
	$"0FED DDEF 0000 0000 0000 0000 FCF0 0000"
	$"FFFF DFFF F000 0000 0000 0000 FCF0 0000"
	$"000F DF00 0000 0000 0000 0000 FCF0 0000"
	$"000F DFFF FFFF FFFF FFFF FFFF FCF0 0000"
	$"000F DDCC CCCC CCCC CCCC CCCC CCF0 0000"
	$"000F FFFF FFFF FFFF FFFF FFFF FFF0"
};

resource 'ics8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF 0000"
	$"0000 FF00 0000 0000 0000 0000 00FF 0000"
	$"0000 FF00 0000 0000 0000 0000 FFFF FF00"
	$"0000 FF00 0000 0000 0000 0000 00FF 0000"
	$"0000 FF00 0000 0000 0000 00FF FFFF FF00"
	$"FFFF FFFF 0000 0000 0000 00FF 2A2A FF00"
	$"FF2A 2AFF 0000 0000 0000 FFFF FFFF FFFF"
	$"FF2B 2BFF 0000 0000 0000 FF2B 2B2B 2BFF"
	$"FFFF FFFF 0000 0000 0000 FFFF FFFF FFFF"
	$"0000 FF00 0000 0000 0000 0000 00FF 0000"
	$"00FF FFFF 0000 0000 0000 0000 00FF 0000"
	$"0000 FF00 0000 0000 0000 0000 00FF 0000"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF"
};

data 'hdlg' (-2999, "DITL 128") {
	$"0002 0000 0000 0000 0000 0000 0001 0004"            /* ................ */
	$"0100 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0001 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000"                                               /* .. */
};

data 'hdlg' (-2997, "DITL 130") {
	$"0002 0000 0000 0000 0000 0000 0014 0004"            /* ................ */
	$"0100 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0002 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0003 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0004 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 FFFF 0000 F448 0005 FFFF 0000 FFFF"            /* .......H........ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0006 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0007 FFFF 0000 F448 0008 FFFF"            /* ...H.......H.... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0009 FFFF 0000 FFFF 0000 FFFF"            /* ...H........... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 000A FFFF 0000 F448 000B FFFF"            /* ...H.......H.... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 000C FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 FFFF 0000 F448 000D FFFF 0000 FFFF"            /* .......H....... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 000E FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 FFFF 0000 F448 000F FFFF 0000 FFFF"            /* .......H........ */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0010 FFFF 0000 F448 0011 FFFF"            /* ...H.......H.... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0012 FFFF 0000 F448 0013 FFFF"            /* ...H.......H.... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0014 FFFF 0000 F448 0015 FFFF"            /* ...H.......H.... */
	$"0000 0020 0003 0000 0000 0000 0000 0000"            /* ... ............ */
	$"0000 F448 0016 FFFF 0000 FFFF 0000 FFFF"            /* ...H............ */
	$"0000 0014 0007 0000 0000 003C 0000 0000"            /* ...........<.... */
	$"0000 0000 0000 0020 0003 0000 0000 0000"            /* ....... ........ */
	$"0000 0000 0000 F448 0017 FFFF 0000 F448"            /* .......H.......H */
	$"0018 FFFF 0000 0020 0003 0000 0000 0000"            /* ....... ........ */
	$"0000 0000 0000 FFFF 0000 F448 0019 FFFF"            /* ...........H.... */
	$"0000 FFFF 0000 0020 0003 0000 0000 0000"            /* ....... ........ */
	$"0000 0000 0000 F448 001A FFFF 0000 FFFF"            /* .......H........ */
	$"0000 FFFF 0000"                                     /* ...... */
};

data 'TEXT' (-3000) {
	$"4D50 696E 670D 0D50 696E 6720 7574 696C"            /* MPingPing util */
	$"6974 7920 666F 7220 4170 706C 6520 4D61"            /* ity for Apple Ma */
	$"6369 6E74 6F73 68AA 2E"                             /* cintosh. */
};

data 'hfdr' (-5696) {
	$"0002 0000 0000 0000 0000 0001 0006 0006"            /* ................ */
	$"F448"                                               /* .H */
};

