/*------------------------------------------------------------------------------
#	MPing 1.1 - MacTCP Ping Tool
#
#	Copyright  Apple Computer, Inc. 1990-1991
#	All rights reserved.
#
#	Versions:	
#				1.1		September 25, 1991.
#
#	File:
#				MPing.c
#
#	Components:
#				AddressXlation.h
#				MacTCPCommonTypes.h
#				Makefile
#				MiscIPPB.h
#				MPing.c
#				MPing.h
#				MPing.r
#				MPingDlg.c
#				MPingExtern.h
#				MPingGlobals.h
#				MPingIcmp.c
#				MPingWindow.c
#				resolver.c
------------------------------------------------------------------------------*/

extern struct PingStatistics gIcmpStat;	/* used to print icmp ping statistics */
extern Rect gMsgRect;
extern char gIPOptionResponse[];

extern struct Record_Route_Info gRecord_route;
extern struct Record_Route_Info gLooseSourceRR;
extern struct Record_Route_Info gStrictSourceRR;
extern struct Security_Info gSecurity_Opt;
extern struct Stream_Indentifier_Info gStream_ID;
extern struct Internet_Timestamp_Info gInternetTimeStamp;

extern Boolean gRR;					/* flag for Record Route option */
extern Boolean gLSRR;				/* flag for Loose Source Record Route option */
extern Boolean gSSRR;				/* flag for Strict Source Record Route option */
extern Boolean gSecurity;			/* flag for Security option */
extern Boolean gSID;				/* flag for Stream ID option */
extern Boolean gTimestamp;			/* flag for Internet Timestamp option */

extern Boolean gIsHostAlive;		/* flag used to determine whether to use time manager or not */

extern Boolean gSessionComplete;	/* if true don't send packet, else do */

extern struct EchoResponseStatus gResponseStatus;	/* status of each response */
extern Boolean gResponsePrinted;
extern Boolean gQuietVerbose;		/* true to quiet, false to verbose */

extern char	gHostAddress[255];	/* Host address */
extern char	gData[255];			/* ICMP data to be transmitted */
extern char	gPattern[255];		/* ICMP data pattern to be transmitted */
extern long	gSize;				/* size of the ICMP packet */
extern long	gCount;				/* no. of ICMP data packets to be transmitted */
extern long	gWait;				/* wait no. of ticks before sending each packet */
extern Boolean gTextPattern;	/* true to send text, false to send pattern */
extern Boolean gQuietVerbose;	/* true to quiet, false to verbose */
extern Boolean gFixedNoOfPkts;	/* true to send fixed no. of packets, false to continue */
extern Boolean gRunning;

extern char gSourceAddress[16];
extern char gDestAddress[16];
