#
#	Quill
#
#	Apple Macintosh User Programming Group
#
#	MultiFinder-Aware, AppleEvents-Aware Simple Styled TextEdit Sample Application
#
#	by Bennet Marks
#
#	Copyright  1991 Apple Computer, Inc.
#
#	Quill based on TEStyleSample  (Copyright  1989 Apple Computer, Inc.)
#
#
#	Quill.make	-	Make Source
#
#	All rights reserved.
#
#	Versions:	1.0						02/18/91
#
#	Components:	Quill.p
#				QuillGlue.a
#				Quill.r
#				Quill.h	
#				Quill.make
#
#	Quill is an example application that demonstrates how 
#	to initialize the commonly used toolbox managers, operate 
#	successfully under MultiFinder, handle desk accessories and 
#	create, grow, and zoom windows. Both styled and fundamental TextEdit 
#	toolbox calls and TextEdit autoscroll are demonstrated. It 
#	also shows how to create and maintain scrollbar controls as well
#	as implementing a basic printing loop.
#
#   It also handles AppleEvents, and is written with an eye towards
#   making it work with the AppleEvents Object Model and the Open Scripting
#   Architecture. It was built on TEStyleSample, with more functionality and
#   AppleEvent awareness added in.
#
#	It does not by any means demonstrate all the techniques you 
#	need for a large application. In particular, Quill does not 
#	cover exception handling, multiple windows/documents, 
#	sophisticated memory management, or undo. All of 
#	these are vital parts of a normal full-sized application.
#
#	This application is an example of the form of a Macintosh 
#	application; it is NOT a template. It is NOT intended to be 
#	used as a foundation for the next world-class, best-selling, 
#	600K application. A stick figure drawing of the human body may 
#	be a good example of the form for a painting, but that does not 
#	mean it should be used as the basis for the next Mona Lisa.
#
#	We recommend that you review this program, TESample or Sample before 
#	beginning a new application. TESample is a simpler version of Quill
#	without styles and Sample is a simple app. which doesnt 
#	use TextEdit or the Control Manager.
#
POptions = -sym full
LinkOptions = -sym full

PObjs	=	Quill.p.o 
			AECompareLib.p.o 
			QuillGlue.a.o 
			"{Libraries}"Runtime.o 
			"{Libraries}"Interface.o 
			"{PLibraries}"AEObjectSupportLib.o 
			"{PLibraries}"PasLib.o

Quill		 {PObjs} Quill.make
			Link -o {Targ} {PObjs}
			SetFile {Targ} -t APPL -c 'quil' -a B

Quill		 Quill.r Quill.h Quill.make Quill.rsrc
			Rez -rd -append -o {Targ} Quill.r
			Rez -a -ov -o Quill AEUserTermTypes.r QuillTerminology.r QuillJapaneseTerminology.r

Quill.p.o	 Quill.p Quill.make
