#ifndef __AUTOGUEST__
#define __AUTOGUEST__

/*----------------------------------------------------------------------

	Install the PPC AutoGuest patch
	
	This patch allows an application to start a session with a
	remote computer without bringing up an authentication dialog
	box if (& only if) it is possible to connect to said machine
	as a guest.  If it is not possible to connect as a guest,
	the authentication dialog box is brought up, but only if
	your application is in the foreground.  (Without this patch,
	StartSecureSession is perfectly happy to bring up the
	authentication dialog box while your application is in the
	background).
	
	This function returns a longword which should be passed to
	DeinstallPPCAutoGuest to remove the patch
	
----------------------------------------------------------------------*/
long InstallPPCAutoGuest(void);

/*----------------------------------------------------------------------
	
	Remove the PPC AutoGuest patch
	
	The parameter should be the longword returned from
	InstallPPCAutoGuest
	
----------------------------------------------------------------------*/
void DeinstallPPCAutoGuest( long oldPPCDispatch );

/*----------------------------------------------------------------------

	Install the 'No Interaction Allowed' Patch
	
	This patch prevents the EPPC toolbox from returning a
	'No User Interaction Allowed' error (-610) if your application
	attempts to start a session while it is in the background.
	
	You should not install this patch unless the 'PPCAutoGuest'
	patch is also installed; if you do, your program will bring
	up an authentication dialog box even if it is in the background.
	This is a bad thing.
	
----------------------------------------------------------------------*/
long InstallNoInteractionPatch(void);

/*----------------------------------------------------------------------
	
	Remove the 'No Interaction Allowed' Patch
	
	The parameter should be the longword returned from
	InstallPPCAutoGuest
	
----------------------------------------------------------------------*/
void DeinstallNoInteractionPatch( long oldDispose );

/*----------------------------------------------------------------------
	
	This function returns 'true' if the current process is in the
	foreground.  It is used by the PPC Autoguest patch.
	
----------------------------------------------------------------------*/
Boolean InForeGround(void);


#endif
