###############################################################################
#   File:       Concordia.make
#   Target:     Concordia
###############################################################################
# Comments about comments
#
# Variable Declaration/Definition Comments
#     All variables that declared and defined have a comment right after them.
# You'll notice that some of those comments are preceded by a -> or a =>.  Read
# these as "pointer to" and "handle to" respectively.
#
# Parameter Declaration Comments
#     All declarations for parameters to functions have a comment just after
# them.  After the comment, you'll see one of three signed: <<, <>, or >>.  The
# sign, <<, means that this parameter is ONLY used to pass information back to
# the calling function.  The sign, >>, means that this parameter is ONLY used
# to pass information to the called function.  The sign, <>, means that this
# parameter is used both to give information to the called function, and to
# return information to the calling function.
#     If the parameter is a pointer, these signs refer to the information that
# is being pointed to.  If the parameter is a handle, these signs refer to the
# information that is being, well, "handled" to.

OBJECTS = 
	Concordia.c.o 
	ChooseTkl.c.o 
	DrawTkl.c.o 
	PopUpTkl.c.o 
	SizeTkl.c.o

DrawTkl.h  Concordia.make Concordia.h
	SetFile -m . DrawTkl.h 

SizeTkl.h  Concordia.make Concordia.h
	SetFile -m . SizeTkl.h

ChooseTkl.c.o  Concordia.make ChooseTkl.c ChooseTkl.h Concordia.h DrawTkl.h 
		SizeTkl.h
	C -b -mbg full -r ChooseTkl.c

Concordia.c.o  Concordia.make Concordia.c ChooseTkl.h Concordia.h DrawTkl.h 
		PopUpTkl.h SizeTkl.h
	C -b -mbg full -r Concordia.c

DrawTkl.c.o  Concordia.make DrawTkl.c Concordia.h DrawTkl.h SizeTkl.h
	C -b -mbg full -r DrawTkl.c

PopUpTkl.c.o  Concordia.make PopUpTkl.c Concordia.h DrawTkl.h PopUpTkl.h 
		SizeTkl.h
	C -b -mbg full -r PopUpTkl.c

SizeTkl.c.o  Concordia.make SizeTkl.c Concordia.h DrawTkl.h SizeTkl.h
	C -b -mbg full -r SizeTkl.c

Concordia  Concordia.make Concordia.r
	Rez -t rsrc -c RSED -a Concordia.r -o Concordia

Concordia  Concordia.make {OBJECTS}
	Link -t rsrc -c RSED -rt MDEF=0 -ra Main=$00 -m MAIN -mf -rn 
		{OBJECTS} 
		"{Libraries}"Interface.o 
		"{Libraries}"Runtime.o 
		-o Concordia
