/*
** File : CMComponent.h
** by Konstantin Othmer
**  1991, 1992 Apple Computer, Inc.  All Rights Reserved
**
** This file contains the definitions necessary for Monet components
**
** version:
**			11/19/91	KON		new today.
*/

#pragma once

#ifndef CMComponent

#define CMComponent

#include "Components.h"
#include "CMApplication.h"

#define 	CMInterfaceVersion	0
#define 	CMCodeVersion		0
#define	CMVersion		((CMInterfaceVersion << 16) | CMCodeVersion)

/*
** Profile Responder Components
*/


#define ProfileResponderInterfaceRev	0
#define ProfileResponderCodeRev		0

#define	kSelectGetProfile 			0		
#define 	kSelectSetProfile 			1	

#define	kProfileResponderMaxSelector	kSelectSetProfile

typedef enum {
	kCMInit 		= 0,
	kCMMatchColors = 1,
	kCMGamutTest	= 2,
	kCMMatchPixMap = 3,
	kCMCheckPixMap = 4,
	kCMConcatenateProfiles = 5
} CMRoutineSelectors;

typedef short CMRoutineSelector;

typedef enum {
	kCMGetProfile	= 0,
	kCMSetProfile	= 1
} CMResponderSelectors;

typedef short CMResponderSelector;

typedef ComponentInstance ProfileResponder;


/*
** Required CMM Component routines
*/

pascal CMError CMInit( ComponentInstance myComponent, CMProfileHandle srcProfile,
			CMProfileHandle dstProfile ) 
	= ComponentCallNow( kCMInit, 0x0008 );	

pascal CMError CMMatchColors( ComponentInstance CMSession, CMColorList myColors, long count ) 
	= ComponentCallNow( kCMMatchColors, 0x0008 );

pascal CMError CMCheckColors( ComponentInstance CMSession, CMColorList myColors, long count, CMGamutResult *result ) 
	= ComponentCallNow( kCMGamutTest, 0x000C );

/*
** Optional CMM Component routines
*/

pascal CMError CMMatchPixMap( ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackProcPtr progressProc )
	= ComponentCallNow( kCMMatchPixMap, 0x0008 );

pascal CMError CMCheckPixMap( ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackProcPtr progressProc, BitMap *myBitMap )
	= ComponentCallNow( kCMCheckPixMap, 0x000C );

pascal CMError CMConcatenateProfiles( ComponentInstance CMSession, CMProfileHandle thru, CMProfileHandle dst, CMProfileHandle *newDst )
	= ComponentCallNow( kCMConcatenateProfiles, 0x000C );

/*
** ProfileResponder Component routines
*/

pascal CMProfileHandle  CMGetProfile( ProfileResponder myProfileResponder ) 
	= ComponentCallNow( kCMGetProfile, 0 );
						
pascal CMError CMSetProfile( ProfileResponder myProfileResponder, CMProfileHandle newProfile ) 
	= ComponentCallNow( kCMSetProfile, 4 );


#endif