/*------------------------------------------------------------------------------
#
#	TV-Man.Ext.h
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#
#	This file contails all global definitions for the application. They are used
#	for communication between different functions and segments of the program.
#	The The "g" prefix is used to emphasize that the variable is global.
#
#	In order to have an evironment which predictable events happen several definitions
#	must be established. The most critical is in the file architecture. Each functional
#	block will have its own source and header file. The main project file,  in this
#	case TV-Man, will have its header file included with all other files. This will
#	allow for global constants. The utility source file shall contain functions that
#	are general purpose in nature and that can be used by all other functions. These
#	are intended not to be application or major block specific. In order for this to be 
#	accomodated all functions in the utility source file must use only the information
#	that is passed to them or information that can be gleaned from the system via
#	toolbox calls. There will be no header file associated with the utility file as this
#	will destroy the intent of the utilities.
#
#	There are several files which contain information which is global in nature .These
#	file are included in the main project header file. They are: x.Errors.h, x.Ext.h,
#	x.Protos.h, x.Menus.h. The reason for containing them in seperate files is one of
#	convienience and accesability. 
#
#
#	Revision Log:
#	
#		4-26-91		RGK		Creation
#
#
------------------------------------------------------------------------------*/


/*------------------------------------------------------------------------------*/
/* GMac is used to hold the result of a SysEnvirons call. This makes
   it convenient for any routine to check the environment. */

extern SysEnvRec	gMac;				/* set up by Initialize */


/*------------------------------------------------------------------------------*/
/* GHasWaitNextEvent is set at startup, and tells whether the WaitNextEvent
   trap is available. If it is false, we know that we must call GetNextEvent. */

extern Boolean		gHasWaitNextEvent;	/* set up by Initialize */



/*------------------------------------------------------------------------------*/
/* GInBackground is maintained by our osEvent handling routines. Any part of
   the program can check it to find out if it is currently in the background. */

extern Boolean		gInBackground;		/* maintained by Initialize and DoEvent */



/*------------------------------------------------------------------------------*/
/*	This is the number which identifies whch video pattern we will and have
	displayed*/

extern short		gLastVideoPattern;	/*	the last test pattern used	*/
extern short		gVideoPattern;		/*	the current test pattern	*/


/*-------------------------------------------------------------------------------*/
/*	These are the globals used in the making of sounds and the sound dialog box	*/

extern BeepChan		gSopranoChan;		/* the current beep channel 1	*/
extern BeepChan		gAltoChan;			/* the current beep channel 2	*/
extern BeepChan		gTenorChan;			/* the current beep channel 3	*/
extern BeepChan		gBassChan;			/* the current beep channel 4	*/
extern BeepChan		gTestChan;			/* the current beep channel for test beep	*/

extern Beep			gBeepData;			/* beep data variables	*/
extern Beep			gBeepDataT;			/* beep data variables for test beep	*/
