/*------------------------------------------------------------------------------
#
#	TV-Man.Protos.h
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#
#	This file containes all of the prototypes of all function calls which are not in
#	the toolbox or other system software.
#
#	In order to have an evironment which predictable events happen several definitions
#	must be established. The most critical is in the file architecture. Each functional
#	block will have its own source and header file. The main project file,  in this
#	case TV-Man, will have its header file included with all other files. This will
#	allow for global constants. The utility source file shall contain functions that
#	are general purpose in nature and that can be used by all other functions. These
#	are intended not to be application or major block specific. In order for this to be 
#	accomodated all functions in the utility source file must use only the information
#	that is passed to them or information that can be gleaned from the system via
#	toolbox calls. There will be no header file associated with the utility file as this
#	will destroy the intent of the utilities.
#
#	There are several files which contain information which is global in nature .These
#	file are included in the main project header file. They are: x.Errors.h, x.Ext.h,
#	x.Protos.h, x.Menus.h. The reason for containing them in seperate files is one of
#	convienience and accesability. 
#
#
#	Revision Log:
#	
#		4-26-91		RGK		Creation
#
#
------------------------------------------------------------------------------*/

/*---------------------------------------------------------------*/
/*	Functions in TV-Man.c	*/

void EventLoop( void );
void DoEvent( EventRecord *event );
void AdjustMenus( void );
void DoMenuCommand( long menuResult );
void AdjustCursor( Point mouse, RgnHandle region );
void DrawWindow( WindowPtr window );
Boolean TrapAvailable( short tNumber, TrapType tType );





/*---------------------------------------------------------------*/
/*	Functions in TV-Man.Init.c	*/

void Initialize( void );





/*---------------------------------------------------------------*/
/*	Functions in TV-Man.Utility.c	*/

void DoUpdate( WindowPtr window );
void DoActivate( WindowPtr window, Boolean becomingActive );
void GetGlobalMouse( Point *mouse );
Boolean IsAppWindow( WindowPtr window );
Boolean IsDAWindow( WindowPtr window );
void Error( short type, short error);
Boolean DoCloseWindow( WindowPtr window );
void Terminate( void );
void RangeCheckShort( DialogPtr dialog, short itemid, short minimum, short maximum);
void Short2Text( short value, DialogPtr theDialog, short itemId );
short Text2Short( DialogPtr theDialog, short itemId );
void ToggleControl( ControlHandle control );
short JumpAmount( ControlHandle control, short amount );
short CheckControlRange( short value,  ControlHandle control );
short CheckValueRange( short value, short minimum, short maximum);






/*---------------------------------------------------------------*/
/*	Functions in TV-Man.Video.c	*/

void DrawTestPattern( WindowPtr window );
void DrawColorBars( WindowPtr window );
void DrawRedScreen( WindowPtr window );
void DrawGreenScreen( WindowPtr window );
void DrawBlueScreen( WindowPtr window );
void DrawWhiteScreen( WindowPtr window );
void DrawSingleColor( WindowPtr window, short index);
void DrawGrayScaleLD( WindowPtr window );
void DrawGrayScaleDL( WindowPtr window );
void DrawVertLines( WindowPtr window );
void DrawHorzLines( WindowPtr window );
void DrawLineBurst( WindowPtr window );
void WhereCenter( WindowPtr window, short *hcenter, short *vcenter );
short SizeVBar( WindowPtr window, short number );
void GetGResource( short *depth, short *barcount );
PaletteHandle GrabPalette( WindowPtr window,  short depth, Boolean type );




/*---------------------------------------------------------------*/
/*	Functions in TV-Man.Sound.c	*/

pascal long SoundVersion( void );
pascal void SoundInit( void );
pascal void SoundEnable( void );
pascal void SoundCheck( void );
pascal void SoundStop( void );
pascal void SoundDisable( void );
pascal void SopranoControls( void );
pascal void AltoControls( void );
pascal void TenorControls( void );
pascal void BassControls( void );

void DoSoundControls( short rsrc );
pascal void DrawBeepDone( DialogPtr dialog, short item );
pascal void DrawBeepType( DialogPtr dialog, short item );
pascal Boolean SoundFilter( DialogPtr dialog, EventRecord *event, short *itemhit );
void InitTheValues( DialogPtr dialog, BeepHdl beephdl );
void SaveTheValues( DialogPtr dialog, BeepHdl beephdl, Boolean doit );
void DoBeepTypeMenu( DialogPtr dialog );
void FullRangeCheck( DialogPtr dialog );
void DoSliders( DialogPtr dialog, Point mouseloc, short itemid );
void UpDateSlider( DialogPtr dialog, short itemid );
pascal void SoundScroll( ControlHandle control, short part );
void TestTheBeep( DialogPtr dialog );
void ProcessBeep( BeepCPtr beep );
SndChannelPtr DoSound( BeepHdl beephdl );
void SetUpBeep( BeepHdl beephdl, SndChannelPtr channel);
pascal void SoundIsDone( SndChannelPtr channel, SndCommand command );
void SetAllSounds( void );
void ClearAllSounds( void );
void KillSoundChannels( void );
void KillBeepChannel( BeepCPtr beepchan );
void ForceBeepEnable( BeepCPtr beepchan, Boolean value );
void InitChannel( BeepCPtr beep, short rsrc );
