/*------------------------------------------------------------------------------
#
#	TV-Man.Video.h
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#
#
#
#	This is the file that is common to all Video stuff
#
#	In order to have an evironment which predictable events happen several definitions
#	must be established. The most critical is in the file architecture. Each functional
#	block will have its own source and header file. The main project file,  in this
#	case TV-Man, will have its header file included with all other files. This will
#	allow for global constants. The utility source file shall contain functions that
#	are general purpose in nature and that can be used by all other functions. These
#	are intended not to be application or major block specific. In order for this to be 
#	accomodated all functions in the utility source file must use only the information
#	that is passed to them or information that can be gleaned from the system via
#	toolbox calls. There will be no header file associated with the utility file as this
#	will destroy the intent of the utilities.
#
#	There are several files which contain information which is global in nature .These
#	file are included in the main project header file. They are: x.Errors.h, x.Ext.h,
#	x.Protos.h, x.Menus.h. The reason for containing them in seperate files is one of
#	convienience and accesability. 
#
#
#	Revision Log:
#	
#		04-26-91	RGK		Creation
#
#
------------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/*	Resource root id values	*/

#define rTests			(rVideo * 10)
#define rPalettes		((rVideo * 10) + 1)

/*----------------------------------------------------------------------------*/
/*	Resource Id s	*/

#define	rTestPattern	(rTests * 10)
#define	rVLines			(rTests * 10) + 1
#define	rGrayValues		(rTests * 10) + 2
#define rPalettes		(rTests * 10) + 3
#define rLineBurst		(rTests * 10) + 4

#define rColorPal		(rPalettes * 10)
#define rGPal4			(rPalettes * 10) + 1
#define rGPal8			(rPalettes * 10) + 2



/*----------------------------------------------------------------------------*/
/*	Color Values	*/


#define	MywhiteColor	30		/*	Old QuickDraw value		*/
#define	MygreenColor	341		/*	Old QuickDraw value		*/
#define	MyblueColor		409		/*	Old QuickDraw value		*/
#define	MycyanColor		273		/*	Old QuickDraw value		*/
#define	MymagentaColor	137		/*	Old QuickDraw value		*/
#define MyyellowColor	69		/*	Old QuickDraw value		*/
#define	MyblackColor	33		/*	Old QuickDraw value		*/
#define	MyredColor		205		/*	Old QuickDraw value		*/
#define RedScreenCol	11		/*	pallette Index number	*/
#define GreenScreenCol	7		/*	pallette Index number	*/
#define BlueScreenCol	13		/*	pallette Index number	*/
#define WhiteScreenCol	1		/*	pallette Index number	*/







/*----------------------------------------------------------------------------*/
/*	Misc Video Information	*/

#define	CBarCount	16
#define	ColorDepth	16
#define COLOR		true
#define	GRAY		false




/*----------------------------------------------------------------------------*/
/*	The following line will effectivly eliminate the following typedefs from the 
	this header file during the Rez process because Rez cannot handle typedefs.
	All Resource files will define "__Rezing__" when processing, all C sources
	will not.	*/
	
#ifndef __Rezing__

/*----------------------------------------------------------------------------*/
/*	This is the resource structure for the test pattern	*/

typedef struct
{
	short			LineWidth;
	short			SpaceWidth;
	short			RingWidth;
	long			ForeGColor;
	long			BackGColor;
}	*TPValuesPtr,	**TPValuesHdl;



/*----------------------------------------------------------------------------*/
/*	This is the resource structure for the line patterns	*/

typedef struct
{
	short			LForeGCWidth;
	short			LBackGCWidth;
	long			LForeGColor;
	long			LBackGColor;
}	*LNValuesPtr,	**LNValuesHdl;




/*----------------------------------------------------------------------------*/
/*	This is the resource structure for the line patterns	*/

typedef struct
{
	short		BarCount;
	short		BarWidth;
	short		BarSpace;
	long		BarColor;
	long		BackGColor;
}	*LBurstPtr, **LBurstHdl;



#endif __Rezing__