/*------------------------------------------------------------------------------
#
#	TV-Man.Errors.r	-	Rez Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#	Version:	1.00
#
#	This file contains all of the error messages displayed by an alert box.
#
#	Revision Log:
#	
#		8-2-91		RGK		Creation
#
#
------------------------------------------------------------------------------*/


/*	this will eliminate non Rez statements from the header files	*/

#define	__Rezing__			


/*	Now lets include all of the neecessary files.	*/

#include "TV-Man.h"
#include "SysTypes.r"
#include "Types.r"

#include "TV-Man.Errors.h"




/*------------------------------------------------------------------------------*/
/* this ALRT is used as an error screen for major errors */

resource 'ALRT' (eMajor, "Major Error", purgeable)
{
	{35, 20, 175, 305},
	eMajor,
	
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	},
	centerParentWindow
};




/*------------------------------------------------------------------------------*/
/*	This is the Item List for the Major error Message Box	*/

resource 'DITL' (eMajor, "Major Error Messages", purgeable) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{107, 192, 127, 272},
		Button
		{
			enabled,
			"OK"
		},
		
		/* [2] */
		{8, 51, 63, 273},
		StaticText
		{
			disabled,
			"A Major TV-Man error occurred!\nThe application"
			" will be aborted\nbecause:"
		},
		
		/* [3] */
		{8, 8, 40, 40},
		Icon
		{
			disabled,
			2
		},
		
		/* [4] */
		{67, 51, 100, 273},
		StaticText
		{
			disabled,
			"^0"
		}
	}
};








/* This is the list of major error messages */

resource 'STR#' (eMajor, "Major Error Messages", purgeable)
{
	{
		/* [1] */
		"Need 128K or Bigger ROMs.",
		
		/* [2] */
		"Heap is to small.",
		
		/* [3] */
		"Not enough RAM left.",
		
		/* [4] */
		"Could not open the resource.",
		
		/* [5] */
		"Could not get a Window pointer.",
		
		/* [6] */
		"Could not get the MenuBar pointer.",
		
		/* [7] */
		"Could not open the Dialog Box.",
		
		/* [8] */
		"Can not dispose of the Sound Channel."
	}
};




/*------------------------------------------------------------------------------*/
/* this ALRT is used as an error screen for minor errors */

resource 'ALRT' (eMinor, "Minor Error", purgeable)
{
	{35, 20, 175, 305},
	eMinor,
	
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	},
	centerParentWindow
};





/*------------------------------------------------------------------------------*/
/*	This is the Item List for the Minor error Message Box	*/

resource 'DITL' (eMinor, "Minor Error Messages", purgeable)
{
	{
		/* [1] */
		{107, 192, 127, 272},
		Button
		{
			enabled,
			"OK"
		},
		
		/* [2] */
		{8, 51, 63, 273},
		StaticText
		{
			disabled,
			"A Minor TV-Man error occurred!\nThe function"
			" will be aborted\nbecause:"
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon
		{
			disabled,
			2
		},
		
		/* [4] */
		{67, 51, 100, 273},
		StaticText
		{
			disabled,
			"^0"
		}
	}
};




/* This is the list of minor error messages */

resource 'STR#' (eMinor, "Minor Error Messages", purgeable)
{
	{
		/* [1] */
		"This function is not ready yet!",
		
		/* [2] */
		"The resource could not be opened.",
		
		/* [3] */
		"The dialog could not be opened.",
		
		/* [4] */
		"The menu could not be opened.",
		
		/* [5] */
		"The sound channel could not be opened.",
		
		/* [6] */
		"That Sound is not avaliable.",
		
		/* [7] */
		"Can not dispose of the Sound Channel.",
		
		/* [8]	*/
		"Can not play the assigned Resource."
	}
};
