/*------------------------------------------------------------------------------
#
#	TV-Man.Video.r	-	Rez Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#	Version:	1.00
#
#
#
#	This file containes the resources common to the Video
#
#	Revision Log:
#	
#		8-5-91		RGK		Creation
#
#
------------------------------------------------------------------------------*/


/*	this will eliminate non Rez statements from the header files	*/

#define	__Rezing__			


/*	Now lets include all of the neecessary files.	*/

#include "TV-Man.h"
#include "TV-ManTypes.r"
#include "Types.r"
#include "SysTypes.r"

#include "TV-Man.Video.h"


/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the Test Pattern Generator	*/

resource 'tpat' (rTestPattern, "Test Pattern Values", purgeable)
{
	2,				/*	Line Width					*/
	20,				/*	Step Width	(foreground)	*/
	20,				/*	Ring Width					*/
	MywhiteColor,	/*	ForeGround Color			*/
	MyblackColor	/*	BackGround Color			*/
};




/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the lines generator.	*/

resource 'lnes' (rVLines, "Line Values", purgeable)
{
	1,				/*	Foreground color width	*/
	1,				/*	Background color width	*/
	MyblackColor,	/*	Foreground color		*/
	MywhiteColor	/*	Background color		*/
};




/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the Gray Bars.	*/

resource 'gbrs' (rGrayValues, "Gray Bar Values", purgeable)
{
	16,			/*	the color resolution		*/ 
	16			/*	simply the number of bars	*/
};




/*------------------------------------------------------------------------------*/
/*	This resource controls the line burst display. */

resource 'lbst' (rLineBurst, "Line Burst Values", purgeable)
{
	3,				/*	Number of bars		*/
	2,				/*	Bar Width			*/
	5,				/*	Bar Color			*/
	MywhiteColor,	/*	Bar Color			*/
	MyblackColor	/*	Background Color	*/
};






/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the Color palette. The actual number
	of bars in the display is 16, the colors are duplicted to show the 8
	normal color bars. */

resource 'pltt' (rColorPal, "Color Palette", purgeable)
{
	{	/* array ColorInfo: 16 elements */
		65535, 65535, 65535, pmTolerant, 0,		/*	White	*/
		65535, 65535, 65535, pmTolerant, 0,		/*	White	*/
		65535, 65535, 0, pmTolerant, 0,			/*	Yellow	*/
		65535, 65535, 0, pmTolerant, 0,			/*	Yellow	*/
		0, 65535, 65535, pmTolerant, 0,			/*	Cyan	*/
		0, 65535, 65535, pmTolerant, 0,			/*	Cyan	*/
		0, 65535, 0, pmTolerant, 0,				/*	Green	*/
		0, 65535, 0, pmTolerant, 0,				/*	Green	*/
		65535, 0, 65535, pmTolerant, 0,			/*	Magenta	*/
		65535, 0, 65535, pmTolerant, 0,			/*	Magenta	*/
		65535, 0, 0, pmTolerant, 0,				/*	Red		*/
		65535, 0, 0, pmTolerant, 0,				/*	Red		*/
		0, 0, 65535, pmTolerant, 0,				/*	Blue	*/
		0, 0, 65535, pmTolerant, 0,				/*	Blue	*/
		0, 0, 0, pmTolerant, 0,					/*	Black	*/
		0, 0, 0, pmTolerant, 0					/*	Black	*/
	}
};





/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the Color palette.	*/

resource 'pltt' (rGPal4, "4 Bit Gray Scale", purgeable)
{
	{	/* array ColorInfo: 16 elements */
		/* [1] */
		65535, 65535, 65535, pmTolerant, 0,
		/* [2] */
		61166, 61166, 61166, pmTolerant, 0,
		/* [3] */
		56797, 56797, 56797, pmTolerant, 0,
		/* [4] */
		52428, 52428, 52428, pmTolerant, 0,
		/* [5] */
		48059, 48059, 48059, pmTolerant, 0,
		/* [6] */
		43690, 43690, 43690, pmTolerant, 0,
		/* [7] */
		39321, 39321, 39321, pmTolerant, 0,
		/* [8] */
		34952, 34952, 34952, pmTolerant, 0,
		/* [9] */
		30583, 30583, 30583, pmTolerant, 0,
		/* [10] */
		26214, 26214, 26214, pmTolerant, 0,
		/* [11] */
		21845, 21845, 21845, pmTolerant, 0,
		/* [12] */
		17476, 17476, 17476, pmTolerant, 0,
		/* [13] */
		13107, 13107, 13107, pmTolerant, 0,
		/* [14] */
		8738, 8738, 8738, pmTolerant, 0,
		/* [15] */
		4369, 4369, 4369, pmTolerant, 0,
		/* [16] */
		0, 0, 0, pmTolerant, 0
	}
};







/*------------------------------------------------------------------------------*/
/*	This is the resource definitions for the Gray scale palette.	*/

resource 'pltt' (rGPal8, "8 Bit Gray Scale", purgeable)
{
	{	/* array ColorInfo: 256 elements */
		65535, 65535, 65535, pmTolerant, 0,
		65278, 65278, 65278, pmTolerant, 0,
		65021, 65021, 65021, pmTolerant, 0,
		64764, 64764, 64764, pmTolerant, 0,
		64507, 64507, 64507, pmTolerant, 0,
		64250, 64250, 64250, pmTolerant, 0,
		63993, 63993, 63993, pmTolerant, 0,
		63736, 63736, 63736, pmTolerant, 0,
		63479, 63479, 63479, pmTolerant, 0,
		63222, 63222, 63222, pmTolerant, 0,
		62965, 62965, 62965, pmTolerant, 0,
		62708, 62708, 62708, pmTolerant, 0,
		62451, 62451, 62451, pmTolerant, 0,
		62194, 62194, 62194, pmTolerant, 0,
		61937, 61937, 61937, pmTolerant, 0,
		61680, 61680, 61680, pmTolerant, 0,
		61423, 61423, 61423, pmTolerant, 0,
		61166, 61166, 61166, pmTolerant, 0,
		60909, 60909, 60909, pmTolerant, 0,
		60652, 60652, 60652, pmTolerant, 0,
		60395, 60395, 60395, pmTolerant, 0,
		60138, 60138, 60138, pmTolerant, 0,
		59881, 59881, 59881, pmTolerant, 0,
		59624, 59624, 59624, pmTolerant, 0,
		59367, 59367, 59367, pmTolerant, 0,
		59110, 59110, 59110, pmTolerant, 0,
		58853, 58853, 58853, pmTolerant, 0,
		58596, 58596, 58596, pmTolerant, 0,
		58339, 58339, 58339, pmTolerant, 0,
		58082, 58082, 58082, pmTolerant, 0,
		57825, 57825, 57825, pmTolerant, 0,
		57568, 57568, 57568, pmTolerant, 0,
		57311, 57311, 57311, pmTolerant, 0,
		57054, 57054, 57054, pmTolerant, 0,
		56797, 56797, 56797, pmTolerant, 0,
		56540, 56540, 56540, pmTolerant, 0,
		56283, 56283, 56283, pmTolerant, 0,
		56026, 56026, 56026, pmTolerant, 0,
		55769, 55769, 55769, pmTolerant, 0,
		55512, 55512, 55512, pmTolerant, 0,
		55255, 55255, 55255, pmTolerant, 0,
		54998, 54998, 54998, pmTolerant, 0,
		54741, 54741, 54741, pmTolerant, 0,
		54484, 54484, 54484, pmTolerant, 0,
		54227, 54227, 54227, pmTolerant, 0,
		53970, 53970, 53970, pmTolerant, 0,
		53713, 53713, 53713, pmTolerant, 0,
		53456, 53456, 53456, pmTolerant, 0,
		53199, 53199, 53199, pmTolerant, 0,
		52942, 52942, 52942, pmTolerant, 0,
		52685, 52685, 52685, pmTolerant, 0,
		52428, 52428, 52428, pmTolerant, 0,
		52171, 52171, 52171, pmTolerant, 0,
		51914, 51914, 51914, pmTolerant, 0,
		51657, 51657, 51657, pmTolerant, 0,
		51400, 51400, 51400, pmTolerant, 0,
		51143, 51143, 51143, pmTolerant, 0,
		50886, 50886, 50886, pmTolerant, 0,
		50629, 50629, 50629, pmTolerant, 0,
		50372, 50372, 50372, pmTolerant, 0,
		50115, 50115, 50115, pmTolerant, 0,
		49858, 49858, 49858, pmTolerant, 0,
		49601, 49601, 49601, pmTolerant, 0,
		49344, 49344, 49344, pmTolerant, 0,
		49087, 49087, 49087, pmTolerant, 0,
		48830, 48830, 48830, pmTolerant, 0,
		48573, 48573, 48573, pmTolerant, 0,
		48316, 48316, 48316, pmTolerant, 0,
		48059, 48059, 48059, pmTolerant, 0,
		47802, 47802, 47802, pmTolerant, 0,
		47545, 47545, 47545, pmTolerant, 0,
		47288, 47288, 47288, pmTolerant, 0,
		47031, 47031, 47031, pmTolerant, 0,
		46774, 46774, 46774, pmTolerant, 0,
		46517, 46517, 46517, pmTolerant, 0,
		46260, 46260, 46260, pmTolerant, 0,
		46003, 46003, 46003, pmTolerant, 0,
		45746, 45746, 45746, pmTolerant, 0,
		45489, 45489, 45489, pmTolerant, 0,
		45232, 45232, 45232, pmTolerant, 0,
		44975, 44975, 44975, pmTolerant, 0,
		44718, 44718, 44718, pmTolerant, 0,
		44461, 44461, 44461, pmTolerant, 0,
		44204, 44204, 44204, pmTolerant, 0,
		43947, 43947, 43947, pmTolerant, 0,
		43690, 43690, 43690, pmTolerant, 0,
		43433, 43433, 43433, pmTolerant, 0,
		43176, 43176, 43176, pmTolerant, 0,
		42919, 42919, 42919, pmTolerant, 0,
		42662, 42662, 42662, pmTolerant, 0,
		42405, 42405, 42405, pmTolerant, 0,
		42148, 42148, 42148, pmTolerant, 0,
		41891, 41891, 41891, pmTolerant, 0,
		41634, 41634, 41634, pmTolerant, 0,
		41377, 41377, 41377, pmTolerant, 0,
		41120, 41120, 41120, pmTolerant, 0,
		40863, 40863, 40863, pmTolerant, 0,
		40606, 40606, 40606, pmTolerant, 0,
		40349, 40349, 40349, pmTolerant, 0,
		40092, 40092, 40092, pmTolerant, 0,
		39835, 39835, 39835, pmTolerant, 0,
		39578, 39578, 39578, pmTolerant, 0,
		39321, 39321, 39321, pmTolerant, 0,
		39064, 39064, 39064, pmTolerant, 0,
		38807, 38807, 38807, pmTolerant, 0,
		38550, 38550, 38550, pmTolerant, 0,
		38293, 38293, 38293, pmTolerant, 0,
		38036, 38036, 38036, pmTolerant, 0,
		37779, 37779, 37779, pmTolerant, 0,
		37522, 37522, 37522, pmTolerant, 0,
		37265, 37265, 37265, pmTolerant, 0,
		37008, 37008, 37008, pmTolerant, 0,
		36751, 36751, 36751, pmTolerant, 0,
		36494, 36494, 36494, pmTolerant, 0,
		36237, 36237, 36237, pmTolerant, 0,
		35980, 35980, 35980, pmTolerant, 0,
		35723, 35723, 35723, pmTolerant, 0,
		35466, 35466, 35466, pmTolerant, 0,
		35209, 35209, 35209, pmTolerant, 0,
		34952, 34952, 34952, pmTolerant, 0,
		34695, 34695, 34695, pmTolerant, 0,
		34438, 34438, 34438, pmTolerant, 0,
		34181, 34181, 34181, pmTolerant, 0,
		33924, 33924, 33924, pmTolerant, 0,
		33667, 33667, 33667, pmTolerant, 0,
		33410, 33410, 33410, pmTolerant, 0,
		33153, 33153, 33153, pmTolerant, 0,
		32896, 32896, 32896, pmTolerant, 0,
		32639, 32639, 32639, pmTolerant, 0,
		32382, 32382, 32382, pmTolerant, 0,
		32125, 32125, 32125, pmTolerant, 0,
		31868, 31868, 31868, pmTolerant, 0,
		31611, 31611, 31611, pmTolerant, 0,
		31354, 31354, 31354, pmTolerant, 0,
		31097, 31097, 31097, pmTolerant, 0,
		30840, 30840, 30840, pmTolerant, 0,
		30583, 30583, 30583, pmTolerant, 0,
		30326, 30326, 30326, pmTolerant, 0,
		30069, 30069, 30069, pmTolerant, 0,
		29812, 29812, 29812, pmTolerant, 0,
		29555, 29555, 29555, pmTolerant, 0,
		29298, 29298, 29298, pmTolerant, 0,
		29041, 29041, 29041, pmTolerant, 0,
		28784, 28784, 28784, pmTolerant, 0,
		28527, 28527, 28527, pmTolerant, 0,
		28270, 28270, 28270, pmTolerant, 0,
		28013, 28013, 28013, pmTolerant, 0,
		27756, 27756, 27756, pmTolerant, 0,
		27499, 27499, 27499, pmTolerant, 0,
		27242, 27242, 27242, pmTolerant, 0,
		26985, 26985, 26985, pmTolerant, 0,
		26728, 26728, 26728, pmTolerant, 0,
		26471, 26471, 26471, pmTolerant, 0,
		26214, 26214, 26214, pmTolerant, 0,
		25957, 25957, 25957, pmTolerant, 0,
		25700, 25700, 25700, pmTolerant, 0,
		25443, 25443, 25443, pmTolerant, 0,
		25186, 25186, 25186, pmTolerant, 0,
		24929, 24929, 24929, pmTolerant, 0,
		24672, 24672, 24672, pmTolerant, 0,
		24415, 24415, 24415, pmTolerant, 0,
		24158, 24158, 24158, pmTolerant, 0,
		23901, 23901, 23901, pmTolerant, 0,
		23644, 23644, 23644, pmTolerant, 0,
		23387, 23387, 23387, pmTolerant, 0,
		23130, 23130, 23130, pmTolerant, 0,
		22873, 22873, 22873, pmTolerant, 0,
		22616, 22616, 22616, pmTolerant, 0,
		22359, 22359, 22359, pmTolerant, 0,
		22102, 22102, 22102, pmTolerant, 0,
		21845, 21845, 21845, pmTolerant, 0,
		21588, 21588, 21588, pmTolerant, 0,
		21331, 21331, 21331, pmTolerant, 0,
		21074, 21074, 21074, pmTolerant, 0,
		20817, 20817, 20817, pmTolerant, 0,
		20560, 20560, 20560, pmTolerant, 0,
		20303, 20303, 20303, pmTolerant, 0,
		20046, 20046, 20046, pmTolerant, 0,
		19789, 19789, 19789, pmTolerant, 0,
		19532, 19532, 19532, pmTolerant, 0,
		19275, 19275, 19275, pmTolerant, 0,
		19018, 19018, 19018, pmTolerant, 0,
		18761, 18761, 18761, pmTolerant, 0,
		18504, 18504, 18504, pmTolerant, 0,
		18247, 18247, 18247, pmTolerant, 0,
		17990, 17990, 17990, pmTolerant, 0,
		17733, 17733, 17733, pmTolerant, 0,
		17476, 17476, 17476, pmTolerant, 0,
		17219, 17219, 17219, pmTolerant, 0,
		16962, 16962, 16962, pmTolerant, 0,
		16705, 16705, 16705, pmTolerant, 0,
		16448, 16448, 16448, pmTolerant, 0,
		16191, 16191, 16191, pmTolerant, 0,
		15934, 15934, 15934, pmTolerant, 0,
		15677, 15677, 15677, pmTolerant, 0,
		15420, 15420, 15420, pmTolerant, 0,
		15163, 15163, 15163, pmTolerant, 0,
		14906, 14906, 14906, pmTolerant, 0,
		14649, 14649, 14649, pmTolerant, 0,
		14392, 14392, 14392, pmTolerant, 0,
		14135, 14135, 14135, pmTolerant, 0,
		13878, 13878, 13878, pmTolerant, 0,
		13621, 13621, 13621, pmTolerant, 0,
		13364, 13364, 13364, pmTolerant, 0,
		13107, 13107, 13107, pmTolerant, 0,
		12850, 12850, 12850, pmTolerant, 0,
		12593, 12593, 12593, pmTolerant, 0,
		12336, 12336, 12336, pmTolerant, 0,
		12079, 12079, 12079, pmTolerant, 0,
		11822, 11822, 11822, pmTolerant, 0,
		11565, 11565, 11565, pmTolerant, 0,
		11308, 11308, 11308, pmTolerant, 0,
		11051, 11051, 11051, pmTolerant, 0,
		10794, 10794, 10794, pmTolerant, 0,
		10537, 10537, 10537, pmTolerant, 0,
		10280, 10280, 10280, pmTolerant, 0,
		10023, 10023, 10023, pmTolerant, 0,
		9766, 9766, 9766, pmTolerant, 0,
		9509, 9509, 9509, pmTolerant, 0,
		9252, 9252, 9252, pmTolerant, 0,
		8995, 8995, 8995, pmTolerant, 0,
		8738, 8738, 8738, pmTolerant, 0,
		8481, 8481, 8481, pmTolerant, 0,
		8224, 8224, 8224, pmTolerant, 0,
		7967, 7967, 7967, pmTolerant, 0,
		7710, 7710, 7710, pmTolerant, 0,
		7453, 7453, 7453, pmTolerant, 0,
		7196, 7196, 7196, pmTolerant, 0,
		6939, 6939, 6939, pmTolerant, 0,
		6682, 6682, 6682, pmTolerant, 0,
		6425, 6425, 6425, pmTolerant, 0,
		6168, 6168, 6168, pmTolerant, 0,
		5911, 5911, 5911, pmTolerant, 0,
		5654, 5654, 5654, pmTolerant, 0,
		5397, 5397, 5397, pmTolerant, 0,
		5140, 5140, 5140, pmTolerant, 0,
		4883, 4883, 4883, pmTolerant, 0,
		4626, 4626, 4626, pmTolerant, 0,
		4369, 4369, 4369, pmTolerant, 0,
		4112, 4112, 4112, pmTolerant, 0,
		3855, 3855, 3855, pmTolerant, 0,
		3598, 3598, 3598, pmTolerant, 0,
		3341, 3341, 3341, pmTolerant, 0,
		3084, 3084, 3084, pmTolerant, 0,
		2827, 2827, 2827, pmTolerant, 0,
		2570, 2570, 2570, pmTolerant, 0,
		2313, 2313, 2313, pmTolerant, 0,
		2056, 2056, 2056, pmTolerant, 0,
		1799, 1799, 1799, pmTolerant, 0,
		1542, 1542, 1542, pmTolerant, 0,
		1285, 1285, 1285, pmTolerant, 0,
		1028, 1028, 1028, pmTolerant, 0,
		771, 771, 771, pmTolerant, 0,
		514, 514, 514, pmTolerant, 0,
		257, 257, 257, pmTolerant, 0,
		0, 0, 0, pmTolerant, 0
	}
};
