/*------------------------------------------------------------------------------
#
#	TV-Man.r	-	Rez Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#	Version:	1.00
#
#
#
#	This file containes the resources which only (usually) show up once
#
#	Revision Log:
#	
#		11-05-91	RGK		Changed Rev for single color screens additions
#		04-26-91	RGK		Creation
#
#
------------------------------------------------------------------------------*/



/*	this will eliminate non Rez statements from the header files	*/

#define	__Rezing__			


/*	Now lets include all of the neecessary files.	*/

#include "TV-Man.h"
#include "SysTypes.r"
#include "Types.r"




	
/*------------------------------------------------------------------------------*/
/* this ALRT is used as an About screen */

resource 'ALRT' (rAboutAlert, "About", purgeable)
{
	{41, 19, 180, 341},
	rAboutAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	},
	centerParentWindow
};





/*------------------------------------------------------------------------------*/
/*	This is the Item List for the About Box	*/

resource 'DITL' (rAboutAlert, "About Box", purgeable) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{111, 227, 131, 307},
		Button
		{
			enabled,
			"OK"
		},
		
		/* [2] */
		{8, 8, 25, 306},
		StaticText
		{
			disabled,
			"TV-Man the monitor diagnostic. Version 0"
			".02"
		},
		
		/* [3] */
		{32, 8, 48, 296},
		StaticText
		{
			disabled,
			"Copyright  Apple Computer 1989-1991"
		},
		/* [4] */
		{56, 8, 72, 136},
		StaticText
		{
			disabled,
			"Brought to you by:"
		},
		
		/* [5] */
		{85, 26, 120, 171},
		StaticText
		{
			disabled,
			"Robert Kowolik\nof CPU Diagnostics"
		}
	}
};






/*------------------------------------------------------------------------------*/
/*	Now the Version details	*/
resource 'vers' (1)
{
	0x00,
	0x00,
	development,
	0x00,
	verUS,
	"0.02",
	"0.02, Copyright \251 Apple Computer, Inc. 1989-1990"
};






/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1)
{
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	multiFinderAware,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	dontGetFrontClicks,			/* change this is if you want "do first click" behavior like the Finder */
	ignoreChildDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	not32BitCompatible,			/* this app should not be run in 32-bit address space */
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};




type 'TVMN' as 'STR ';
resource 'TVMN' (0)
{
	"TV-Man test"
};




resource 'FREF' (rFref)
{
	'APPL',0, ""
};




resource 'ICN#' (rIcon)
{
	{	/* array: 2 elements */
		/* [1] */
		$"0000 00E0 0000 0300 03E0 0400 0410 0800"
		$"0808 1000 0008 2000 0006 4000 0001 C000"
		$"0003 E000 1FFF FFF8 1000 0008 1000 0008"
		$"107F FE08 11A4 0188 111A 0088 12AD 5848"
		$"1256 AC48 122B D648 1295 2A48 124A B648"
		$"122D 5848 121E A448 1217 DA48 110B C888"
		$"1184 0188 107F FE08 1000 0008 1180 1508"
		$"1180 0008 1000 0008 1000 0008 1FFF FFF8",
		/* [2] */
		$"0000 07F0 03E0 0FF0 0FF0 1F00 0FF8 3E00"
		$"1C3C 7C00 081F F800 001F F000 000F F000"
		$"000F F000 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
	}
};

resource 'ics#' (rIcon)
{
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0C0C 1210 0120 01C0 1FFC 1004 13E4"
		$"1694 1554 1494 13E4 1004 1464 1004 1FFC",
		/* [2] */
		$"1E1E 3F3F 0FFE 07F0 07F0 3FFE 3FFE 3FFE"
		$"3FFE 3FFE 3FFE 3FFE 3FFE 3FFE 3FFE 3FFE"
	}
};

resource 'icl8' (rIcon)
{
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFFF FF00 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFFF 0000 0000 0000 0000"
	$"0000 0000 0000 FFFF FFFF FF00 0000 0000"
	$"0000 0000 00FF 0000 0000 0000 0000 0000"
	$"0000 0000 00FF 0000 0000 00FF 0000 0000"
	$"0000 0000 FF00 0000 0000 0000 0000 0000"
	$"0000 0000 FF00 0000 0000 0000 FF00 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FF00 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FF FF00"
	$"00FF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FF"
	$"FFFF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FFFF"
	$"FFFF FF00 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FF00 0000"
	$"0000 00FF F9F9 F9F9 F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9FC FCFC FCFC FCFC"
	$"FCFC FCFC FCFC FCF9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9FD FC00 0000 0000 0000"
	$"0000 0000 0000 00FC FDF9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9FC 0000 00FF FF00 FF00"
	$"0000 0000 0000 0000 FCF9 F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 FF00 FF00 FFFF 00FF"
	$"00FF 00FF FF00 0000 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 00FF 00FF 00FF FF00"
	$"FF00 FF00 FFFF 0000 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 0000 FF00 FF00 FFFF"
	$"FFFF 00FF 00FF FF00 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 FF00 00FF 00FF 00FF"
	$"0000 FF00 FF00 FF00 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 00FF 0000 FF00 FF00"
	$"FF00 FFFF 00FF FF00 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 0000 FF00 FFFF 00FF"
	$"00FF 00FF FF00 0000 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 0000 00FF FFFF FF00"
	$"FF00 FF00 00FF 0000 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 FC00 0000 00FF 00FF FFFF"
	$"FFFF 00FF FF00 FF00 00FC F9F9 FF00 0000"
	$"0000 00FF F9F9 F9FD 0000 0000 FF00 FFFF"
	$"FFFF 0000 FF00 0000 FDF9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9FC FD00 0000 0000 0000"
	$"0000 0000 0000 00FD FCF9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9FC FCFC FCFC FCFC"
	$"FCFC FCFC FCFC FCFA F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 FFFF F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9FF F9FF F9FF F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 FFFF F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF F9F9 F9F9 F9F9 F9F9 F9F9 F9F9"
	$"F9F9 F9F9 F9F9 F9F9 F9F9 F9F9 FF00 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'icl4' (rIcon)
{
	$"0000 0000 0000 0000 0000 0000 FFF0 0000"
	$"0000 0000 0000 0000 0000 00FF 0000 0000"
	$"0000 00FF FFF0 0000 0000 0F00 0000 0000"
	$"0000 0F00 000F 0000 0000 F000 0000 0000"
	$"0000 F000 0000 F000 000F 0000 0000 0000"
	$"0000 0000 0000 F000 00F0 0000 0000 0000"
	$"0000 0000 0000 0FF0 0F00 0000 0000 0000"
	$"0000 0000 0000 000F FF00 0000 0000 0000"
	$"0000 0000 0000 00FF FFF0 0000 0000 0000"
	$"000F FFFF FFFF FFFF FFFF FFFF FFFF F000"
	$"000F BBBB BBBB BBBB BBBB BBBB BBBB F000"
	$"000F BBBB BBBB BBBB BBBB BBBB BBBB F000"
	$"000F BBBB BFFF FFFF FFFF FFFB BBBB F000"
	$"000F BBBF F0F0 0F00 0000 000F FBBB F000"
	$"000F BBBF 000F F0F0 0000 0000 FBBB F000"
	$"000F BBF0 F0F0 FF0F 0F0F F000 0FBB F000"
	$"000F BBF0 0F0F 0FF0 F0F0 FF00 0FBB F000"
	$"000F BBF0 00F0 F0FF FF0F 0FF0 0FBB F000"
	$"000F BBF0 F00F 0F0F 00F0 F0F0 0FBB F000"
	$"000F BBF0 0F00 F0F0 F0FF 0FF0 0FBB F000"
	$"000F BBF0 00F0 FF0F 0F0F F000 0FBB F000"
	$"000F BBF0 000F FFF0 F0F0 0F00 0FBB F000"
	$"000F BBF0 000F 0FFF FF0F F0F0 0FBB F000"
	$"000F BBBF 0000 F0FF FF00 F000 FBBB F000"
	$"000F BBBF F000 0F00 0000 000F FBBB F000"
	$"000F BBBB BFFF FFFF FFFF FFFB BBBB F000"
	$"000F BBBB BBBB BBBB BBBB BBBB BBBB F000"
	$"000F BBBF FBBB BBBB BBBF BFBF BBBB F000"
	$"000F BBBF FBBB BBBB BBBB BBBB BBBB F000"
	$"000F BBBB BBBB BBBB BBBB BBBB BBBB F000"
	$"000F BBBB BBBB BBBB BBBB BBBB BBBB F000"
	$"000F FFFF FFFF FFFF FFFF FFFF FFFF F0"
};

resource 'ics8' (rIcon)
{
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 FFFF 0000 0000 0000 FFFF 0000"
	$"0000 00FF 0000 FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 00FF 0000 FF00 0000 0000"
	$"0000 0000 0000 00FF FFFF 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF 0000"
	$"0000 00FF FBFB FBFB FBFB FBFB FBFF 0000"
	$"0000 00FF FBFB FFFF FFFF FFFB FBFF 0000"
	$"0000 00FF FBFF FF00 FF00 00FF FBFF 0000"
	$"0000 00FF FBFF 00FF 00FF 00FF FBFF 0000"
	$"0000 00FF FBFF 0000 FF00 00FF FBFF 0000"
	$"0000 00FF FBFB FFFF FFFF FFFB FBFF 0000"
	$"0000 00FF FBFB FBFB FBFB FBFB FBFF 0000"
	$"0000 00FF FBFF FBFB FBFF FFFB FBFF 0000"
	$"0000 00FF FBFB FBFB FBFB FBFB FBFF 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ics4' (rIcon)
{
	$"0000 0000 0000 0000 0000 FF00 0000 FF00"
	$"000F 00F0 000F 0000 0000 000F 00F0 0000"
	$"0000 000F FF00 0000 000F FFFF FFFF FF00"
	$"000F BBBB BBBB BF00 000F BBFF FFFB BF00"
	$"000F BFF0 F00F BF00 000F BF0F 0F0F BF00"
	$"000F BF00 F00F BF00 000F BBFF FFFB BF00"
	$"000F BBBB BBBB BF00 000F BFBB BFFB BF00"
	$"000F BBBB BBBB BF00 000F FFFF FFFF FF"
};




resource 'BNDL' (0) 			/* allow finder to find ICON for APPL */
{
	'TVMN', 0,					/* signature  & ID # */
		{
		'FREF',					/* FILE TYPE ID references */
			{0, rFref},
		'ICN#',					/* APPL & OUTPUT FILE ICON IDs */
			{0, rIcon}
		}	
}; 
